(***********************************************************************
 * File: Addressing.v
 * $Revision: 12365 $
 * $Date: 2014-03-12 18:50:32 -0300 (Wed, 12 Mar 2014) $
 * $LastChangedBy: jdcampo $
 *************************************************************************
 * This file specifies the different types of addreses.
 * 
 *************************************************************************)

(** Virtual addresses. *)
Parameter vadd: Set.
Parameter vadd_eq : forall va1 va2 : vadd, {va1 = va2} + {va1 <> va2}.

(** Machine addresses. *)
Parameter madd :  Set.
Parameter madd_eq : forall ma1 ma2 : madd, {ma1 = ma2} + {ma1 <> ma2}.

(** Physical addresses : 
The OSes use the physical addresses in order to see 
contiguous regions of memory. They don't see the machine addresses. *)
Parameter padd: Set.
Parameter padd_eq : forall pa1 pa2 : padd, {pa1 = pa2} + {pa1 <> pa2}.

(** Memory values. *)
Parameter value: Set.
Parameter value_eq:forall val1 val2 : value, {val1 = val2} + {val1 <> val2}.

Inductive ptype : Set :=
(** Page Table PD/PT *)
| PT : ptype 
(** Read Write Access *)
| RW: ptype.
