(***********************************************************************
 * File: Dict_unbound.v
 * $Revision: 12365 $
 * $Date: 2014-03-12 18:50:32 -0300 (Wed, 12 Mar 2014) $
 * $LastChangedBy: jdcampo $
 *************************************************************************
 * This file specifies a unbounded dictionary
 * 
 *************************************************************************)
Module Type DICT_UNBOUND.

Parameter dict : Set.

Parameter key : Set.
Parameter info : Set.
Parameter eq_key : forall (k k':key), {k = k'} + {k <> k'}.

Parameter empty : dict.
Parameter set : dict -> key -> info -> dict.
Parameter is_empty : dict -> Prop.
Parameter get : dict -> key -> option info.
Parameter remove : dict -> key -> dict.

(* Dict behavior *)
Axiom is_empty_empty : is_empty empty.
Axiom not_empty_set : forall (d:dict) (k:key) (inf:info),
  ~ is_empty (set d k inf).

Axiom get_empty : forall (k:key), get empty k = None.
Axiom get_set : forall (d:dict) (k:key) (inf:info),
  Some inf = get (set d k inf) k.
Axiom get_set_distinct : forall (d:dict) (k k':key) (inf:info),
  k <> k' ->
  get (set d k inf) k' = get d k'.


Axiom get_remove : forall (d:dict) (k:key),
  get (remove d k) k = None.

Axiom get_remove_distinct : forall (d:dict) (k k':key) (inf:info),
  k <> k' -> get d k = Some inf -> get (remove d k') k = Some inf.

Axiom get_remove_old : forall (d:dict) (k k':key) (inf:info),
  get (remove d k') k = Some inf -> get d k = Some inf.
End DICT_UNBOUND.





