Require Export State State_valid Tactics State_tactics Exec_invariant_init.

Module EXEC_INV_INJ_HYPER (C:CACHE PG) (SMEM:SYSTEM_MEM PG C T MM) (ST:STATE C SMEM)
  (ACT:ACTIONS C SMEM ST) (ST_VALID:ST_VALID C SMEM ST)
  (EI:EXEC_INV_INIT C SMEM ST ACT ST_VALID).

  Import PG.
  Import C.
  Import T.
  Import SMEM.
  Import ST.
  Import ST_VALID.
  Import EI.

Lemma injective_hyper_mappings_inv :
  forall (s s' : state) (a : action),
    ACT.valid_exec s a s' ->
      valid_state s ->
         injective_hyper_mappings (st_hypervisor s').
Proof.
  unfold valid_state; crush.
  unfold injective_hyper_mappings; crush.
  destruct H3 with osi; crush.

  STAC.action_induction a; intros; crush;
    STAC.destruct_action_sem;
    unfold injective_hyper_mappings in *.
  
  (* page pin untrusted *)
  destruct (padd_eq pa1 pa2); crush.
  destruct (os_ident_eq osi o); crush.
  (* osi = o *)
  rewrite <- HYP.get_set in *; crush.
  destruct (padd_eq p pa1); crush.
  rewrite <- P2M.get_set in *; crush.
  rewrite P2M.get_set_distinct in *; crush.
  assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); crush;
    unfold madd_owner in *; crush.
  rewrite (P2M.get_set_distinct) in H15; crush.
  destruct (padd_eq p pa2); crush.
  rewrite <- P2M.get_set in *; crush.
  assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); crush;
    unfold madd_owner in *; crush.
  rewrite (P2M.get_set_distinct) in *; crush.
  (* osi <> o *)
  rewrite HYP.get_set_distinct in *; crush.

  (* page unpin untrusted *)
  destruct (padd_eq pa1 pa2); crush.
  destruct (os_ident_eq osi o); crush.
  (* osi = o *)
  rewrite <- HYP.get_set in *; crush.
  destruct (padd_eq p pa1); crush.
  rewrite P2M.get_remove in *; crush.
  destruct (padd_eq p pa2); crush.
  rewrite P2M.get_remove in *; crush.
  assert (P2M.get x1 pa1 = Some ma);
    [rewrite <- (P2M.get_remove_old x1 pa1 p); crush|].
  assert (P2M.get x1 pa2 = Some ma);
    [rewrite <- (P2M.get_remove_old x1 pa2 p)|]; crush.
  (* osi <> o *)
  rewrite HYP.get_set_distinct in *; crush.
Qed.  

End EXEC_INV_INJ_HYPER.