(***********************************************************************
 * File: Read_Isolation.v
 * $Revision: 12365 $
 * $Date: 2014-03-12 18:50:32 -0300 (Wed, 12 Mar 2014) $
 * $LastChangedBy: jdcampo $
 ***********************************************************************
 * This files proves read isolation property on valid executions. 
 **********************************************************************)
Require Import State State_valid State_tactics.


Module READ_ISOLATION (C:CACHE PG) (SMEM:SYSTEM_MEM PG C T MM)
  (ST:STATE C SMEM) (ACT:ACTIONS C SMEM ST) (ST_VALID:ST_VALID C SMEM ST).

  Import PG.
  Import C.
  Import T.
  Import ST.
  Import ST_VALID.
  Module STAC := STAC C SMEM ST ACT ST_VALID.

  Definition read_isolation (s s':state) : Prop :=
    forall (va:vadd), 
      valid_state s -> 
      ACT.valid_exec s (Read va) s' ->
      aos_page_owner s va = Some (Os_PO (st_active_os s)).

  Theorem read_isolation_proof :
    forall s s', read_isolation s s'.
  Proof.
    unfold read_isolation, aos_page_owner; intros;
      STAC.destruct_action_sem.
    erewrite STAC.valid_state_aos_page_owner; crush.
  Qed.

End READ_ISOLATION.
