/*
salsa20-ref.c version 20051118
D. J. Bernstein
Public domain.
*/

#include <stdio.h>
#include "ecrypt-sync.h"

#define ROTATE(v,c) (ROTL32(v,c))
#define XOR(v,w) ((v) ^ (w))
#define PLUS(v,w) (U32V((v) + (w)))
#define PLUSONE(v) (PLUS((v),1))

u8 output[64];

u32 x_wordtobyte[16]; //MODIFIED FOR THE STEALTHMEM ANALYSIS

static void salsa20_wordtobyte(u8 output[64],const u32 input[16])
{
  //  u32 x[16]; MODIFIED FOR THE STEALTHMEM ANALYSIS
  int i;

  //  for (i = 0;i < 16;++i) x_wordtobyte[i] = input[i]; MODIFIED FOR THE STEALTHMEM ANALYSIS
  x_wordtobyte[0] = input[0]; // LOOP ENROLLING (MODIFIED FOR THE STEALTHMEM ANALYSIS)
  x_wordtobyte[1] = input[1];
  x_wordtobyte[2] = input[2];
  x_wordtobyte[3] = input[3];
  x_wordtobyte[4] = input[4];
  x_wordtobyte[5] = input[5];
  x_wordtobyte[6] = input[6];
  x_wordtobyte[7] = input[7];
  x_wordtobyte[8] = input[8];
  x_wordtobyte[9] = input[9];
  x_wordtobyte[10] = input[10];
  x_wordtobyte[11] = input[11];
  x_wordtobyte[12] = input[12];
  x_wordtobyte[13] = input[13];
  x_wordtobyte[14] = input[14];
  x_wordtobyte[15] = input[15]; // END LOOP ENROLLING

  for (i = 20;i > 0;i -= 2) {
    x_wordtobyte[ 4] = XOR(x_wordtobyte[ 4],ROTATE(PLUS(x_wordtobyte[ 0],x_wordtobyte[12]), 7));
    x_wordtobyte[ 8] = XOR(x_wordtobyte[ 8],ROTATE(PLUS(x_wordtobyte[ 4],x_wordtobyte[ 0]), 9));
    x_wordtobyte[12] = XOR(x_wordtobyte[12],ROTATE(PLUS(x_wordtobyte[ 8],x_wordtobyte[ 4]),13));
    x_wordtobyte[ 0] = XOR(x_wordtobyte[ 0],ROTATE(PLUS(x_wordtobyte[12],x_wordtobyte[ 8]),18));
    x_wordtobyte[ 9] = XOR(x_wordtobyte[ 9],ROTATE(PLUS(x_wordtobyte[ 5],x_wordtobyte[ 1]), 7));
    x_wordtobyte[13] = XOR(x_wordtobyte[13],ROTATE(PLUS(x_wordtobyte[ 9],x_wordtobyte[ 5]), 9));
    x_wordtobyte[ 1] = XOR(x_wordtobyte[ 1],ROTATE(PLUS(x_wordtobyte[13],x_wordtobyte[ 9]),13));
    x_wordtobyte[ 5] = XOR(x_wordtobyte[ 5],ROTATE(PLUS(x_wordtobyte[ 1],x_wordtobyte[13]),18));
    x_wordtobyte[14] = XOR(x_wordtobyte[14],ROTATE(PLUS(x_wordtobyte[10],x_wordtobyte[ 6]), 7));
    x_wordtobyte[ 2] = XOR(x_wordtobyte[ 2],ROTATE(PLUS(x_wordtobyte[14],x_wordtobyte[10]), 9));
    x_wordtobyte[ 6] = XOR(x_wordtobyte[ 6],ROTATE(PLUS(x_wordtobyte[ 2],x_wordtobyte[14]),13));
    x_wordtobyte[10] = XOR(x_wordtobyte[10],ROTATE(PLUS(x_wordtobyte[ 6],x_wordtobyte[ 2]),18));
    x_wordtobyte[ 3] = XOR(x_wordtobyte[ 3],ROTATE(PLUS(x_wordtobyte[15],x_wordtobyte[11]), 7));
    x_wordtobyte[ 7] = XOR(x_wordtobyte[ 7],ROTATE(PLUS(x_wordtobyte[ 3],x_wordtobyte[15]), 9));
    x_wordtobyte[11] = XOR(x_wordtobyte[11],ROTATE(PLUS(x_wordtobyte[ 7],x_wordtobyte[ 3]),13));
    x_wordtobyte[15] = XOR(x_wordtobyte[15],ROTATE(PLUS(x_wordtobyte[11],x_wordtobyte[ 7]),18));
    x_wordtobyte[ 1] = XOR(x_wordtobyte[ 1],ROTATE(PLUS(x_wordtobyte[ 0],x_wordtobyte[ 3]), 7));
    x_wordtobyte[ 2] = XOR(x_wordtobyte[ 2],ROTATE(PLUS(x_wordtobyte[ 1],x_wordtobyte[ 0]), 9));
    x_wordtobyte[ 3] = XOR(x_wordtobyte[ 3],ROTATE(PLUS(x_wordtobyte[ 2],x_wordtobyte[ 1]),13));
    x_wordtobyte[ 0] = XOR(x_wordtobyte[ 0],ROTATE(PLUS(x_wordtobyte[ 3],x_wordtobyte[ 2]),18));
    x_wordtobyte[ 6] = XOR(x_wordtobyte[ 6],ROTATE(PLUS(x_wordtobyte[ 5],x_wordtobyte[ 4]), 7));
    x_wordtobyte[ 7] = XOR(x_wordtobyte[ 7],ROTATE(PLUS(x_wordtobyte[ 6],x_wordtobyte[ 5]), 9));
    x_wordtobyte[ 4] = XOR(x_wordtobyte[ 4],ROTATE(PLUS(x_wordtobyte[ 7],x_wordtobyte[ 6]),13));
    x_wordtobyte[ 5] = XOR(x_wordtobyte[ 5],ROTATE(PLUS(x_wordtobyte[ 4],x_wordtobyte[ 7]),18));
    x_wordtobyte[11] = XOR(x_wordtobyte[11],ROTATE(PLUS(x_wordtobyte[10],x_wordtobyte[ 9]), 7));
    x_wordtobyte[ 8] = XOR(x_wordtobyte[ 8],ROTATE(PLUS(x_wordtobyte[11],x_wordtobyte[10]), 9));
    x_wordtobyte[ 9] = XOR(x_wordtobyte[ 9],ROTATE(PLUS(x_wordtobyte[ 8],x_wordtobyte[11]),13));
    x_wordtobyte[10] = XOR(x_wordtobyte[10],ROTATE(PLUS(x_wordtobyte[ 9],x_wordtobyte[ 8]),18));
    x_wordtobyte[12] = XOR(x_wordtobyte[12],ROTATE(PLUS(x_wordtobyte[15],x_wordtobyte[14]), 7));
    x_wordtobyte[13] = XOR(x_wordtobyte[13],ROTATE(PLUS(x_wordtobyte[12],x_wordtobyte[15]), 9));
    x_wordtobyte[14] = XOR(x_wordtobyte[14],ROTATE(PLUS(x_wordtobyte[13],x_wordtobyte[12]),13));
    x_wordtobyte[15] = XOR(x_wordtobyte[15],ROTATE(PLUS(x_wordtobyte[14],x_wordtobyte[13]),18));
  }
  //  for (i = 0;i < 16;++i) x_wordtobyte[i] = PLUS(x_wordtobyte[i],input[i]);  MODIFIED FOR THE STEALTHMEM ANALYSIS
  x_wordtobyte[0] = PLUS(x_wordtobyte[i],input[0]); // LOOP ENROLLING (MODIFIED FOR THE STEALTHMEM ANALYSIS)
  x_wordtobyte[1] = PLUS(x_wordtobyte[i],input[1]);
  x_wordtobyte[2] = PLUS(x_wordtobyte[i],input[2]);
  x_wordtobyte[3] = PLUS(x_wordtobyte[i],input[3]);
  x_wordtobyte[4] = PLUS(x_wordtobyte[i],input[4]);
  x_wordtobyte[5] = PLUS(x_wordtobyte[i],input[5]);
  x_wordtobyte[6] = PLUS(x_wordtobyte[i],input[6]);
  x_wordtobyte[7] = PLUS(x_wordtobyte[i],input[7]);
  x_wordtobyte[8] = PLUS(x_wordtobyte[i],input[8]);
  x_wordtobyte[9] = PLUS(x_wordtobyte[i],input[9]);
  x_wordtobyte[10] = PLUS(x_wordtobyte[i],input[10]);
  x_wordtobyte[11] = PLUS(x_wordtobyte[i],input[11]);
  x_wordtobyte[12] = PLUS(x_wordtobyte[i],input[12]);
  x_wordtobyte[13] = PLUS(x_wordtobyte[i],input[13]);
  x_wordtobyte[14] = PLUS(x_wordtobyte[i],input[14]);
  x_wordtobyte[15] = PLUS(x_wordtobyte[i],input[15]); // END LOOP ENROLLING

  for (i = 0;i < 16;++i) U32TO8_LITTLE(output + 4 * i,x_wordtobyte[i]);
}

void ECRYPT_init(void)
{
  return;
}

static const char sigma[16] = "expand 32-byte k";
static const char tau[16] = "expand 16-byte k";

void ECRYPT_keysetup(ECRYPT_ctx *x,const u8 *k,u32 kbits,u32 ivbits)
{
  const char *constants;

  x->input[1] = U8TO32_LITTLE(k + 0);
  x->input[2] = U8TO32_LITTLE(k + 4);
  x->input[3] = U8TO32_LITTLE(k + 8);
  x->input[4] = U8TO32_LITTLE(k + 12);
  if (kbits == 256) { /* recommended */
    k += 16;
    constants = sigma;
  } else { /* kbits == 128 */
    constants = tau;
  }
  x->input[11] = U8TO32_LITTLE(k + 0);
  x->input[12] = U8TO32_LITTLE(k + 4);
  x->input[13] = U8TO32_LITTLE(k + 8);
  x->input[14] = U8TO32_LITTLE(k + 12);
  x->input[0] = U8TO32_LITTLE(constants + 0);
  x->input[5] = U8TO32_LITTLE(constants + 4);
  x->input[10] = U8TO32_LITTLE(constants + 8);
  x->input[15] = U8TO32_LITTLE(constants + 12);
}

void ECRYPT_ivsetup(ECRYPT_ctx *x,const u8 *iv)
{
  x->input[6] = U8TO32_LITTLE(iv + 0);
  x->input[7] = U8TO32_LITTLE(iv + 4);
  x->input[8] = 0;
  x->input[9] = 0;
}

void ECRYPT_encrypt_bytes(ECRYPT_ctx *x,const u8 *m,u8 *c,u32 bytes)
{
  int i;

  if (!bytes) return;
  for (;;) {
    salsa20_wordtobyte(output,x->input);
    x->input[8] = PLUSONE(x->input[8]);
    if (!x->input[8]) {
      x->input[9] = PLUSONE(x->input[9]);
      /* stopping at 2^70 bytes per nonce is user's responsibility */
    }
    if (bytes <= 64) {
      for (i = 0;i < bytes;++i) c[i] = m[i] ^ output[i];
      return;
    }
    for (i = 0;i < 64;++i) c[i] = m[i] ^ output[i];
    bytes -= 64;
    c += 64;
    m += 64;
  }
}

void ECRYPT_decrypt_bytes(ECRYPT_ctx *x,const u8 *c,u8 *m,u32 bytes)
{
  ECRYPT_encrypt_bytes(x,c,m,bytes);
}

void ECRYPT_keystream_bytes(ECRYPT_ctx *x,u8 *stream,u32 bytes)
{
  u32 i;
  for (i = 0;i < bytes;++i) stream[i] = 0;
  ECRYPT_encrypt_bytes(x,stream,stream,bytes);
}


u8 m[4096];
u8 c[4096];
u8 d[4096];
u8 k[32];
u8 v[8];

main()
{
  ECRYPT_ctx x; 
  int i;
  int bytes;
  int loop;

  for (loop = 0;loop < 10;++loop) {
    for (bytes = 0;bytes <= 4096;++bytes) {
      if (loop & 1)
        ECRYPT_keysetup(&x,k,256,64);
      else
        ECRYPT_keysetup(&x,k,128,64);
      ECRYPT_ivsetup(&x,v);
      ECRYPT_encrypt_bytes(&x,m,c,bytes);
      ECRYPT_ivsetup(&x,v);
      ECRYPT_decrypt_bytes(&x,c,d,bytes);
      //      for (i = 0;i < bytes;++i) MODIFIED FOR THE STEALTHMEM ANALYSIS
      //	if (d[i] != m[i]) printf("mismatch at position %d/%d\n",i,bytes); MODIFIED FOR THE STEALTHMEM ANALYSIS
      switch(bytes % 3) {
	case 0: for (i = 0;(i < bytes) && (i < 32);++i) k[i] ^= c[i]; break;
	case 1: for (i = 0;(i < bytes) && (i < 8);++i) v[i] ^= c[i]; break;
	case 2: for (i = 0;i < bytes;++i) m[i] = c[i]; break;
      }
    }
    //    for (i = 0;i < 32;++i) printf("%02x",k[i]); printf("\n"); fflush(stdout); MODIFIED FOR THE STEALTHMEM ANALYSIS
  }

  for (loop = 0;loop < 134217728;++loop) {
    ECRYPT_encrypt_bytes(&x,c,c,4096);
  }
  //  for (i = 0;i < 16;++i) printf("%02x",k[i]); printf("\n"); fflush(stdout); MODIFIED FOR THE STEALTHMEM ANALYSIS

  return 0;
}
