Require Import Sets.Constructive_sets
  Stealth_actions Stealth_valid Stealth_lemmas.

Module VALID_SM_STATE_INV.
  Import PG C T MM SMEM ST ST_VALID OS_ISO
         STEALTH_ACTIONS VALID_SM_STATE STEALTH_LEMMAS.

  Lemma valid_state_invariant_sm :
  forall (s s' : state) (a : sm_action),
    valid_sm_state s ->
    valid_sm_exec s a s' ->
    valid_state s'.
  Proof.
    Local Hint Resolve new_normal_eq_old_new
      new_sm_eq_old_new.

    unfold valid_sm_state; crush.

    sm_action_induction a.
    eapply EXEC_INV.valid_state_invariant;
      unfold valid_sm_exec, ACT.valid_exec in *; crush.

    (* New normal *)
    apply EXEC_INV.valid_state_invariant
      with s (New_untrusted o v p); crush.

    (* New sm *)
    remember (os_ident_eq o (st_active_os s)).
    destruct s0; crush.
    destruct new_sm_eq_old_new_active with s s' p; crush.
    unfold valid_sm_state; crush.
    assert (valid_state x).
    apply EXEC_INV.valid_state_invariant
      with s (New_untrusted (st_active_os s) C.stealth_va p); crush.
    apply EXEC_INV.valid_state_invariant
      with x (Read_hyper C.stealth_va); crush.
    apply EXEC_INV.valid_state_invariant
      with s (New_untrusted o C.stealth_va p); crush.
    
  
    (* Switch *)
    destruct_sm_action_sem; crush.
    unfold ACT.pre_switch in Hpre; crush.
    unfold ctxt_switch_new_smem in Hpost; crush.
    Focus 2.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    rewrite Hpost with pt_addr;
      unfold osi_current_page_table; crush.
    unfold valid_state; crush; STAC.get_aos_data;
      STAC.get_aos_current_pt_page; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    remember (remove_osi_stealth_page (ctxt_switch (st_memory s)) m) as smem'.
    remember (State o (st_oss s) (st_exec_mode s)
      (st_aos_activity s) (st_hypervisor s) smem') as s''.
    destruct remove_osi_stealth_page_valid_state with s s'' o (st_oss s) m.
    unfold valid_sm_state; crush.
    crush.
    crush.
    STAC.destruct_valid_state; crush.
    crush.
    apply valid_currpg_remove_osi_stealh_page; crush.
    crush.
    assert (exists pt_addr, osi_current_page_table s o = Some pt_addr).
    STAC.destruct_valid_state_H H.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold osi_current_page_table; crush.
    destruct H10.
    specialize (Hpost x H10).
    rename x into pt_addr.
    rewrite Hpost; clear Hpost.
    assert (o = st_active_os s''); [crush|].
    rewrite H11; rewrite H11 in H10, H7. 
    clear H11.
    replace (st_oss s) with (st_oss s''); [|crush].
    replace (st_exec_mode s) with (st_exec_mode s''); [|crush].
    replace (st_aos_activity s) with (st_aos_activity s''); [|crush].
    replace (st_hypervisor s) with (st_hypervisor s''); [|crush].
    replace smem' with (st_memory s''); [|crush].
    assert (hyper_running s''); [crush|].
    assert (osi_hypercall s'' (st_active_os s'') = None); [crush|].
    assert (osi_current_page_table s'' (st_active_os s'') = Some pt_addr).
    unfold osi_current_page_table in *; crush.
    clear Heqs'' Heqsmem' Hdef o. clear dependent s.
    rename s'' into s.

    remember (madd_of_vadd (smem_mm (st_memory s)) pt_addr C.stealth_va).
    destruct o.
    apply EXEC_INV.valid_state_invariant with s (Read_hyper C.stealth_va); crush.
    unfold ACT.valid_exec; crush; unfold ACT.pre_read_hyper, ACT.pre_all_read,
      ACT.post_read_hyper, ACT.post_all_read; crush.
    2: unfold aos_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    unfold osi_current_page_table in *; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr pt_page pt
      C.stealth_va m0; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite H2 in Heqopt_res; crush.
    remember (get_cache (smem_c (st_memory s)) (C.stealth_va,m0)).
    destruct o; crush.
    destruct H9 with pt_addr m0 p; crush.
    unfold osi_pa_to_ma; crush.
    exists (st_active_os s); exists (os_current_page aos); crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_page_of_vadd_smem, aos_current_page_table,
      osi_current_page_table, page_of_vadd_smem, madd_of_vadd_smem; crush.
    rewrite H_valid_tlb with C.stealth_va m1 pt_addr in Heqo; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_page_of_vadd_smem, aos_current_page_table,
      osi_current_page_table, page_of_vadd_smem, madd_of_vadd_smem; crush.
    rewrite H_valid_tlb with C.stealth_va m1 pt_addr in Heqo; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct H9 with pt_addr m1 x; crush.
    exists (st_active_os s); exists (os_current_page aos); crush.
    unfold osi_pa_to_ma; crush.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct H9 with pt_addr m0 x; crush.
    exists (st_active_os s); exists (os_current_page aos); crush.
    unfold osi_pa_to_ma; crush.
    unfold page_of_vadd_madd_smem; crush.

    replace (page_smem_smem (get (st_memory s) C.stealth_va pt_addr)) with
      (st_memory s); crush.
    rewrite get_invalid; crush.
    unfold page_of_vadd_smem, madd_of_vadd_smem; crush.
    STAC.destruct_valid_state.
    rewrite H_valid_tlb with (ma:=m0) in Heqo; crush.
    rewrite <- Heqo; crush.


    (* Lswitch *)
    destruct_sm_action_sem.
    unfold ACT.pre_lswitch in Hpre; crush.
    specialize (Hpost x H0); crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    unfold ctxt_switch_new_smem; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    remember (remove_osi_stealth_page (ctxt_switch (st_memory s)) pt_addr) as smem'.
    remember (State (st_active_os s)
      (OSS.set (st_oss s) (st_active_os s) (OS None p))
      (st_exec_mode s) (st_aos_activity s) (st_hypervisor s) smem') as s''.
    destruct  remove_osi_stealth_page_valid_state with s s'' (st_active_os s)
      (OSS.set (st_oss s) (st_active_os s) (OS None p)) pt_addr.
    unfold valid_sm_state; crush.
    crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    crush.
    crush.
    unfold valid_os_idents; crush.
    destruct (os_ident_eq osi (st_active_os s)); crush.
    rewrite <- OSS.get_set; crush.
    rewrite OSS.get_set_distinct; crush.
    unfold valid_current_page; crush.
    destruct (os_ident_eq osi (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    exists x; crush.
    unfold madd_type in *; crush.
    exists p0; crush.
    unfold osi_pa_to_ma in *; crush.
    unfold remove_osi_stealth_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    rewrite H14; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_cache in Heqval1; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i m p2; crush.
    destruct (madd_eq m x); crush.
    remember (page_content p0).
    destruct c; crush.
    destruct H_valid_cache with v x p2; crush.
    unfold is_rw_page in *; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    unfold is_pt_page; crush.
    remember (page_content p0).
    destruct c; crush.
    unfold osi_pa_to_ma in *; crush.
    rewrite <- H_valid_hyper with (p2m:=p2m) (pa:=p) (ma:=x); crush.
    unfold madd_owner; crush.
    rewrite OSS.get_set_distinct in *; crush.
    destruct H_valid_currpg with osi system p2m0; crush.
    unfold remove_osi_stealth_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    rewrite H14; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i m p1; crush.
    rewrite ctxt_switch_mem; crush.
    exists x0; exists x1; crush.
    destruct (madd_eq m x0); crush.
    destruct H_valid_cache with v x0 p1; crush.
    unfold is_rw_page, is_pt_page in *; crush.
    rewrite get_add_mem_distinct; crush.    
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    crush.

    assert (st_active_os s = st_active_os s''); [crush|].
    rewrite H17.
    rewrite H17 in H15, H_hyp, H_oss.
    replace (OSS.set (st_oss s) (st_active_os s'') (OS None p))
      with (st_oss s''); [|crush].
    replace (st_exec_mode s) with (st_exec_mode s''); [|crush].
    replace (st_aos_activity s) with (st_aos_activity s''); [|crush].
    replace (st_hypervisor s) with (st_hypervisor s''); [|crush].
    replace (st_hypervisor s) with (st_hypervisor s'') in H_hyp; [|crush].
    replace smem' with (st_memory s''); [|crush].
    assert (hyper_running s''); [crush|].
    assert (osi_pa_to_ma s'' (st_active_os s'') p = Some x).
    unfold osi_pa_to_ma in *; crush.
    assert (madd_type (smem_mm (st_memory s'')) x = Some PT).
    unfold osi_pa_to_ma in H19; crush.
    unfold valid_sm_state in *; crush.
    STAC.destruct_valid_state_H H13.
    STAC.get_aos_data; crush.
    rewrite <- OSS.get_set in H_oss0; crush.
    destruct H_valid_currpg0 with (st_active_os s) (OS None p) p2m; crush.
    rewrite <- OSS.get_set; crush.
    unfold madd_type in *; crush.
    unfold is_pt_page in H21; crush.
    rewrite H21; crush.
    assert (aos_current_page_table s'' = Some x).
    crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold osi_pa_to_ma in *; crush.
    rewrite <- OSS.get_set; crush.
    clear Heqs'' Heqsmem' Hdef. clear dependent s.
    clear dependent aos.
    clear dependent p2m.
    clear dependent pt_addr.
    rename s'' into s.
    
    remember (madd_of_vadd (smem_mm (st_memory s)) x C.stealth_va).
    destruct o.
    apply EXEC_INV.valid_state_invariant with s (Read_hyper C.stealth_va); crush.
    unfold ACT.valid_exec; crush; unfold ACT.pre_read_hyper, ACT.pre_all_read,
      ACT.post_read_hyper, ACT.post_all_read; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    destruct H_valid_virtmap with (st_active_os s) x pt_page0 pt0
      C.stealth_va m; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite H2 in Heqopt_res; crush.
    remember (get_cache (smem_c (st_memory s)) (C.stealth_va,m)).
    destruct o; crush.
    destruct H16 with x m p0; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_page_of_vadd_smem, aos_current_page_table,
      osi_current_page_table, page_of_vadd_smem, madd_of_vadd_smem; crush.
    rewrite H_valid_tlb with C.stealth_va m0 x in Heqo; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_page_of_vadd_smem, aos_current_page_table,
      osi_current_page_table, page_of_vadd_smem, madd_of_vadd_smem; crush.
    rewrite H_valid_tlb with C.stealth_va m0 x in Heqo; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct H16 with x m0 x0; crush.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct H16 with x m x0; crush.
    unfold page_of_vadd_madd_smem; crush.

    replace (page_smem_smem (get (st_memory s) C.stealth_va x)) with
      (st_memory s); crush.
    rewrite get_invalid; crush.
    unfold page_of_vadd_smem, madd_of_vadd_smem; crush.
    STAC.destruct_valid_state.
    rewrite H_valid_tlb with (ma:=m) in Heqo; crush.
    rewrite <- Heqo; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.

    (* o is not the AOS *)
    unfold ACT.pre_lswitch in Hpre; crush.
    specialize (Hpost x H0); crush.
    STAC.destruct_valid_state.
    unfold valid_state; crush.
    destruct H_valid_os_idents with o; crush.
    unfold valid_os_idents; crush.
    destruct (os_ident_eq o osi); inv_crush.
    (* o = osi *)
    inv_crush.
    unfold valid_current_page; crush.    
    destruct (os_ident_eq o osi); crush.
    unfold madd_type in *; crush.
    remember (page_content p0).
    destruct c; crush.
    exists x; exists p0; inv_crush.
    unfold osi_pa_to_ma in *; crush.
    unfold is_pt_page; crush.
    unfold valid_hypervisor in H_valid_hyper.
    rewrite <- H_valid_hyper with osi p2m p x; crush.
    unfold madd_owner; crush.
    unfold osi_pa_to_ma in *; crush.
    (* o <> osi *)
    rewrite OSS.get_set_distinct in H11; crush.
    unfold valid_tlb; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    unfold aos_current_page_table, osi_current_page_table in H12; inv_crush.
    rewrite OSS.get_set_distinct in Heqopt_res; crush.
    destruct H_valid_currpg with (st_active_os s) i i0; crush. 
    unfold is_pt_page in *; crush.
    rewrite H14; crush.
    rewrite <- H_valid_tlb with va ma pt_addr; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H14; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
  Qed.

  (* Read *)
  Lemma all_read_stealth_page_cached_inv : 
    forall s s' va,
      valid_sm_state s ->
      ACT.pre_all_read va s ->
      ACT.post_all_read va s s' ->
      stealth_page_cached s'.
  Proof.
    unfold ACT.pre_all_read, ACT.post_all_read in *; crush;
      STAC.unify_read_post; crush.
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    unfold page_of_vadd_smem in *; simpl in *.
    remember (madd_of_vadd_smem (st_memory s) pt_addr0 va).
    destruct o; simpl in *.
    remember (snd (add_cache (smem_c (st_memory s)) (va,m) x)) as o.
    destruct o.
    destruct p; destruct c.
    destruct (madd_eq m0 ma).
    (* m0 = ma *)
    subst.
    rewrite get_cache_entry1 with (va':=v) (ma:=m)
      (pg:=x) (pg':=p) in H5; auto.
    injection H5; intro; subst; clear H5.
    assert (get_cache (smem_c (st_memory s)) (v,ma) = Some pg).
    apply STAC.cache_deleted_entry_was_there
      with (va:=va) (ma:=m) (pg:=x); auto.
    unfold valid_sm_state in *.
    destruct H.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v ma pg; crush.
    unfold is_rw_page in H2; crush.
    rewrite get_new_cache with (ma:=m) (pg:=x) (val:=x1);
      crush.
    unfold aos_current_page_table, osi_current_page_table in *;
      crush.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    assert (madd_of_vadd (smem_mm (st_memory s))
      pt_addr C.stealth_va = Some ma); crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H21; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    unfold page_of_vadd_smem in *; crush.
    rewrite get_cache_entry2 with (va':=v) (ma:=m)
      (ma':=ma) (pg:=x) (pg':=pg) in Heqopt_res0; crush.
    remember (page_content p0).
    destruct c; crush.
    remember (page_content p0).
    destruct c; crush.
    rewrite get_cache_entry1 with (va':=v) (ma:=m)
      (ma':=pt_addr) (pg:=x) (pg':=pg) in Heqopt_res0; crush.
    unfold is_rw_page in *; crush.

    destruct (eq_cache_key (C.stealth_va,ma) (va,m)); crush.
    (* (stealth_va,ma) = (va,m) *)
    rewrite <- get_add_cache_cacheable; crush.
    destruct H6 with pt_addr m x0; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H_valid_cache with C.stealth_va m x; crush.
    (* stealth_va <> va *)
    destruct H_valid_virtmap with (st_active_os s)
      pt_addr pt_page pt C.stealth_va ma; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite H21 in *; crush.
    specialize (H20 C.stealth_va_accessible); clear H23.
    destruct H6 with pt_addr ma x0; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    rewrite <- H17 in H25.
    specialize (get_add_cache_distinct (smem_c (st_memory s))
      (va,m) (C.stealth_va,ma) x
      (Page (RW_c (Some x2)) (page_owned_by pg) true)); crush.
    rewrite <- H26; crush; clear H26.
    right; crush.
    exists (v,ma); exists pg; crush.
    clear dependent x2.
    assert (C.get_line va = C.get_line C.stealth_va).
    apply C.cache_inertia with (smem_c (st_memory s))
      m ma x pg; crush.
    assert (va = C.stealth_va); crush.
    unfold no_stealth_page_line in H6.
    apply H14 with pt_addr m; crush.
    unfold madd_of_vadd_smem in *; crush.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (madd_eq m ma); crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr
      C.stealth_va = Some ma); crush.
    unfold madd_of_vadd_smem in *; crush.
    rewrite H_valid_tlb with (ma:=m0) in H26; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.

    rewrite get_page_result with (pg:=x); crush.
    unfold aos_page_of_vadd_smem in *; crush.

    (* m0 <> ma *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr
      C.stealth_va = Some ma).
    unfold aos_current_page_table, osi_current_page_table in *;
      crush.
    unfold valid_sm_state in *.
    destruct H.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold madd_of_vadd, madd_page_table; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite H10; crush.
    rewrite get_cache_entry2 with (va':=v) (ma:=m)
      (ma':=m0) (pg:=x) (pg':=p) in Heqopt_res0; crush.
    remember (page_content p1).
    destruct c; crush.
    remember (page_content p1).
    destruct c; crush.
    rewrite get_cache_entry1 with (va':=v) (ma:=m)
      (ma':=pt_addr) (pg:=x) (pg':=p) in Heqopt_res0; crush.
    assert (get_cache (smem_c (st_memory s)) (v,pt_addr) = Some p);
      crush.
    apply STAC.cache_deleted_entry_was_there
      with (va:=va) (ma:=m) (pg:=x); auto.
    destruct H_valid_cache with v pt_addr p; crush.
    unfold is_rw_page in *; crush.

    rewrite get_cache_entry2 with (va':=v) (ma:=m)
      (ma':=m0) (pg:=x) (pg':=p) in H5; auto.
    unfold valid_sm_state in *.
    destruct H.
    destruct H7.
    destruct H7 with pt_addr ma pg; crush.
    unfold is_rw_page in H2; crush.
    rewrite get_new_cache with (ma:=m) (pg:=x) (val:=x1);
      crush.
    destruct (eq_cache_key (C.stealth_va,ma) (va,m)); crush.
    (* (stealth_va,ma) = (v,m) *)
    rewrite <- get_add_cache_cacheable; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold is_cacheable; crush.
    (* stealth_va <> v *)
    unfold aos_current_page_table, osi_current_page_table in *;
      crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.

    specialize (get_add_cache_distinct (smem_c (st_memory s))
      (va,m) (C.stealth_va,ma) x
      (Page (RW_c (Some x0)) (page_owned_by pg) true)); crush.
    rewrite <- H18; crush.
    right; exists (v,m0); exists p; crush.
    rewrite get_page_result with (pg:=x); crush.
    unfold page_of_vadd_smem; crush.
    
    (* No entry left the cache *)
    rewrite get_mem_unchanged with (ma:=m) (pg:=x) in *;
      auto.
    destruct H.
    destruct H6.
    destruct H6 with pt_addr ma pg; crush.
    unfold is_rw_page in H2; crush.
    rewrite get_new_cache with (ma:=m) (pg:=x) (val:=x1);
      crush.
    destruct (eq_cache_key (C.stealth_va,ma) (va,m)); crush.
    (* (stealth_va,ma) = (va,m) *)
    rewrite <- get_add_cache_cacheable; crush.
    exists x1; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold is_cacheable; crush.
    (* (stealth_va,ma) <> (v,m) *)
    unfold is_rw_page in H9; crush.
    specialize (get_add_cache_distinct (smem_c (st_memory s))
      (va,m) (C.stealth_va,ma) x
      (Page (RW_c (Some x0)) (page_owned_by pg) true)); crush.
    rewrite <- H15; crush.
    rewrite get_page_result with (pg:=x); crush.
    unfold page_of_vadd_smem; crush.
    crush.
  Qed.

  Lemma all_write_stealth_page_cached_inv : 
    forall s s' va val,
      valid_sm_state s ->
      valid_state s' ->
      ACT.pre_all_write va val s ->
      ACT.post_all_write va val s s' ->
      stealth_page_cached s'.
  Proof.
    unfold valid_sm_state, ACT.pre_all_write, ACT.post_all_write in *; 
      crush; STAC.unify_write_post; crush.
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    assert (exists pg, get_cache (smem_c (set (st_memory s) 
                          va pt_addr0 val)) (stealth_va, ma) = Some pg).
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite set_new_cache with (ma:=m) (pg:=x) (old_val:=x0); crush.
    destruct (eq_cache_key (stealth_va,ma) (va,m)); crush.
    (* (stealth_va,ma) = (va,m) *)
    remember (page_cacheable x).
    destruct b; crush.
    rewrite <- get_add_cache_cacheable; crush.
    unfold is_cacheable; crush.
    rewrite <- get_add_cache_non_cacheable; crush.
    exists x; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H7 with pt_addr0 m x; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    exists (st_active_os s); exists (os_current_page i); crush.
    unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state_H H.
    apply H_valid_tlb; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_cacheable in *; crush.
    (* (stealth_va,ma) <> (va,m) *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
             Some ma).
    generalize H11; intros.
    unfold madd_of_vadd, madd_page_table in H11; crush.
    remember (page_content p0).
    destruct c; crush.
    erewrite <- STAC.write_same_madd_of_vadd_s' in H13; 
      unfold is_pt_page, is_rw_page; eauto.
    assert (exists stealth_pg_mem, get_mem (smem_mm (st_memory s)) ma = 
      Some stealth_pg_mem).
    STAC.destruct_valid_state_H H.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p0 p1 
      stealth_va ma; crush.
    destruct H_valid_currpg with (st_active_os s) i i0; crush.
    destruct H14.
    destruct H3 with pt_addr ma x1; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    specialize (get_add_cache_distinct (smem_c (st_memory s))
      (va,m) (C.stealth_va,ma) 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x))
      (Page (RW_c (Some x2)) (page_owned_by x1) true)); crush.
    rewrite <- H18; crush.
    destruct o; crush.
    right; crush.
    destruct p; destruct c0.
    exists (v,m0); exists p; crush.
    clear H18.
    assert (va = stealth_va); crush.
    unfold no_stealth_page_line in *; crush.
    apply H8 with pt_addr m; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state_H H.    
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    apply cache_inertia with (smem_c (st_memory s)) m m0 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x)) p; 
      crush.
    assert (m0 = m); crush; clear n.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold madd_of_vadd_smem in *; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
              Some m1); crush.
    STAC.destruct_valid_state_H H.    
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_smem; crush.

    destruct H13.
    assert (valid_cache (State (st_active_os s) (st_oss s)
      (st_exec_mode s) (st_aos_activity s) (st_hypervisor s)
      (set (st_memory s) va pt_addr0 val))).
    STAC.destruct_valid_state_H H0; crush.
    destruct H14 with stealth_va ma x0; crush.
    unfold is_rw_page in H15; crush.
    exists x1; crush.
    rewrite H13; crush.
    destruct x0; crush.
  Qed.
  
  Lemma ctxt_switch_stealth_page_cached : 
    forall s o pt_padd pt_addr ma,
      valid_sm_state s ->
      osi_pa_to_ma s o pt_padd = Some pt_addr ->
      madd_type (smem_mm (st_memory s)) pt_addr = Some PT ->
        madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = Some ma ->
      exists pg, get_cache (smem_c (ctxt_switch_new_smem s pt_addr)) 
                           (stealth_va, ma) = Some pg.
  Proof.
    intros.
    destruct H; crush.
    assert (exists pg, page_of_vadd_madd_smem (st_memory s) 
                                              stealth_va ma = Some pg).
    unfold madd_type in *; crush.
    remember (page_content p).
    destruct c; crush.
    STAC.destruct_valid_state.
    destruct H_valid_virtmap with o pt_addr p p0 stealth_va ma; 
      crush.
    unfold osi_pa_to_ma in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO o); crush.
    unfold osi_pa_to_ma in *; crush.
    unfold madd_owner in *; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p).
    destruct c; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct H9.
    destruct H7 with pt_addr ma x; crush.
    unfold is_rw_page in *; crush.
    unfold ctxt_switch_new_smem; crush.
    rewrite get_new_cache with (ma:=ma) (pg:=x) (val:=x0); crush.
    rewrite <- get_add_cache_cacheable; crush.
    unfold madd_of_vadd_smem; crush.
    unfold remove_osi_stealth_page in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    rewrite H15 in *; crush.
    rewrite flush_ma_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold remove_osi_stealth_page; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H15; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
                                                   v i pt_addr p1; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct H_valid_cache with v pt_addr p1; crush.
    unfold is_rw_page in *; crush.
    rewrite H17 in *; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    apply get_page_result; crush.
    unfold remove_osi_stealth_page; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    rewrite H15; crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    rewrite flush_ma_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_mem; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    unfold page_of_vadd_madd_smem; crush.
    rewrite flush_ma_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    remember (get_cache (smem_c (st_memory s)) (stealth_va,ma)).
    destruct o0; crush.
    rewrite get_remove_ma_cache_ne in Heqval4; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite <- get_remove_ma_cache_ne with (ma:=i) in Heqo0; crush.
    rewrite flush_ma_mem in *; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem; crush.
    destruct (madd_eq m0 ma); crush.
    (* m0 = ma *)
    rewrite <- get_add_mem; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
                                                   v i ma p1; crush.
    destruct (vadd_eq stealth_va v); crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
            Some ma).
    unfold madd_of_vadd, madd_page_table; crush.
    STAC.synonym_cached.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
                                                   v i ma p1; crush.
    destruct (vadd_eq stealth_va v); crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
            Some ma).
    unfold madd_of_vadd, madd_page_table; crush.
    STAC.synonym_cached.
    (* m0 <> ma *)
    rewrite get_add_mem_distinct; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
                                                   v i m0 p1; crush.
    rewrite flush_ma_cache in Heqval4; crush.
    rewrite get_remove_ma_cache_ne in Heqval4; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
                                                   v i pt_addr p1; crush.
    destruct H_valid_cache with v pt_addr p1; crush.
    unfold is_rw_page in *; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite H18 in *; crush.
    rewrite ctxt_switch_mem; crush.
    unfold page_of_vadd_madd_smem; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite get_remove_ma_cache_ne in Heqval4; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_no_entry in Heqval6; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite flush_ma_cache in *; crush.
    rewrite get_remove_ma_cache_ne in Heqval4; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold page_of_vadd_smem, madd_of_vadd_smem; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_mem; crush.
    unfold page_of_vadd_madd_smem; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
  Qed.      


  Lemma stealth_page_cached_inv :
    forall s s' a,
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      stealth_page_cached s'.
  Proof.
    unfold valid_sm_state; crush.

    Ltac prove_same_mem :=
      match goal with
          [H: stealth_page_cached ?s
           |-  context[State _ _ _ _ _ (st_memory ?s)]] =>
        unfold stealth_page_cached; crush;
        match goal with
          [H1: aos_current_page_table _ = Some ?pt_addr,
           H2: madd_of_vadd _ ?pt_addr C.stealth_va = Some ?ma,
           H3: get_mem _ ?ma = Some ?pg |-_] =>
          destruct H with pt_addr ma pg; 
          unfold aos_current_page_table, osi_current_page_table in *; inv_crush;
            inv_crush
        end
    end.

    sm_action_induction a;
      destruct_sm_and_normal_action_sem; crush;
      try match goal with [H:False |-_] => elim H end;
      try prove_same_mem.

    (* Read *)
    apply all_read_stealth_page_cached_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Read_hyper *)
    apply all_read_stealth_page_cached_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Write *)
    apply all_write_stealth_page_cached_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.
    apply EXEC_INV.valid_state_invariant with s (Write v v0); crush;
      unfold ACT.valid_exec; crush;
      unfold ACT.pre_write, ACT.pre_all_write, ACT.post_write; crush.
    
    (* Write hyper *)
    apply all_write_stealth_page_cached_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.
    apply EXEC_INV.valid_state_invariant with s (Write_hyper v v0); crush;
      unfold ACT.valid_exec; crush;
      unfold ACT.pre_write_hyper, ACT.pre_all_write, ACT.post_write_hyper;
      crush.
    
    (* Del untrusted *)
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    assert (exists pg, get_cache (smem_c (ACT.delete_smem o x1 v s)) 
                                 (stealth_va, ma) = Some pg).
    crush.
    rewrite delete_cache with (ma:=x2); crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
            Some ma); crush.
    apply STAC.del_madd_of_vadd_old with 
    (State (st_active_os s)
           (OSS.set (st_oss s) o
                 {| os_hcall := None;
                    os_current_page := os_current_page x0 |})
           (st_exec_mode s) (st_aos_activity s) (st_hypervisor s)
           (ACT.delete_smem o x1 v s)) 
      o v; crush.
    unfold ACT.pre_del, ACT.pre_all_del; crush.
    unfold ACT.post_del; crush.
    assert (exists pg, get_cache (smem_c (st_memory s)) (stealth_va, ma) = Some pg).
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold madd_of_vadd, madd_page_table in H16; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p0 
      p1 stealth_va ma; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    destruct H1 with pt_addr ma x; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    
    destruct H17.
    rewrite get_remove_cache_distinct with (pg:=x); crush.
    assert (madd_of_vadd (smem_mm (delete (st_memory s) x1 stealth_va)) 
                         pt_addr stealth_va = None); crush.
    apply STAC.del_madd_of_vadd_new_va_none with (s:=s) (osi:=o) (ma:=x2)
    (s':=
       (State (st_active_os s)
              (OSS.set (st_oss s) o
                       {| os_hcall := None;
                          os_current_page := os_current_page x0 |})
              (st_exec_mode s) (st_aos_activity s) (st_hypervisor s)
              (ACT.delete_smem o x1 stealth_va s))); crush.
    unfold ACT.pre_del, ACT.pre_all_del; crush.
    unfold ACT.post_del; crush.
    assert (o = (st_active_os s)); crush.
    assert (madd_owner (smem_mm (st_memory s)) x2 = 
              Os_PO(st_active_os s)); crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold madd_of_vadd, madd_page_table in H16; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p0 
      p1 stealth_va x2; crush.
    destruct H_valid_currpg with (st_active_os s) aos p2m; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    unfold madd_owner; crush.
    assert (madd_owner (smem_mm (st_memory s)) x2 = 
              Os_PO o); crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p0).
    destruct c; crush.
    unfold osi_current_page_table in *; crush.
    destruct H_valid_virtmap with o x1 p0 p1 stealth_va x2; crush.
    destruct H_valid_currpg with o x0 i0; crush.
    unfold madd_owner in *; crush.
    rewrite <- OSS.get_set in *; crush.
    unfold osi_current_page_table; crush.
    
    destruct H16.

    assert (valid_state
              (State (st_active_os s)
                     (OSS.set (st_oss s) o
                              {| os_hcall := None;
                                 os_current_page := os_current_page x0 |})
                     (st_exec_mode s) (st_aos_activity s) (st_hypervisor s)
                     (ACT.delete_smem o x1 v s))).
    apply EXEC_INV.valid_state_invariant with 
      s (Del_untrusted o v); crush; unfold ACT.valid_exec; crush;
      unfold ACT.pre_del, ACT.pre_all_del, ACT.post_del; crush.
    
    STAC.destruct_valid_state_H H17.
    destruct H_valid_cache with stealth_va ma x; crush.
    unfold is_rw_page in H18; crush.
    exists x3; crush.
    rewrite H16; crush.
    destruct x; crush.

    (* Page pin *) 
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    unfold madd_of_vadd, madd_page_table in H21; simpl in *.
    assert (ma <> x).
    crush.
    rewrite <- get_add_mem in *; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct (madd_eq x pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    injection Heqc; crush.
    rewrite PT.get_empty in H21; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H1 with pt_addr x x2; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq p (os_current_page x1)); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold is_rw_page in *; crush.
    rewrite get_add_mem_distinct in H22; auto.
    destruct (madd_eq x pt_addr).
    subst x.
    rewrite <- get_add_mem in *; simpl in *.
    rewrite PT.get_empty in *; crush.
    rewrite get_add_mem_distinct in H21; auto.
    destruct H1 with pt_addr ma pg; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- HYP.get_set in *; crush.
    rewrite <- OSS.get_set in *; crush.
    destruct (padd_eq p (os_current_page x1)); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.

    (* Page pin *) 
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    unfold madd_of_vadd, madd_page_table in H21; simpl in *.
    assert (ma <> x).
    crush.
    rewrite <- get_add_mem in *; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct (madd_eq x pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H1 with pt_addr x x2; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq p (os_current_page x1)); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold is_rw_page in *; crush.
    rewrite get_add_mem_distinct in H22; auto.
    destruct (madd_eq x pt_addr).
    subst x.
    rewrite <- get_add_mem in *; simpl in *.
    crush.
    rewrite get_add_mem_distinct in H21; auto.
    destruct H1 with pt_addr ma pg; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- HYP.get_set in *; crush.
    rewrite <- OSS.get_set in *; crush.
    destruct (padd_eq p (os_current_page x1)); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.

    (* Page unpin *)
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    unfold madd_of_vadd, madd_page_table in H18; simpl in *.
    assert (x0 <> pt_addr).
    crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in H18; auto.
    remember (get_mem (smem_mm (st_memory s)) pt_addr).
    destruct o0; simpl in *; try (crush; fail).
    remember (page_content p0).
    destruct c; simpl in *; try (crush; fail).
    assert (aos_current_page_table s = Some pt_addr).
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    apply P2M.get_remove_old with (k':=p); crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    clear H17.
    assert (ma <> x0).
    crush.
    rewrite <- get_add_mem in *; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (o = st_active_os s); crush.
    assert (madd_owner (smem_mm (st_memory s))  x3 = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    assert (madd_owner (smem_mm (st_memory s))  x3 = Os_PO (st_active_os s));
            crush.
    STAC.destruct_valid_state.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr 
      p0 p1 stealth_va x3; crush.
    destruct H_valid_currpg with (st_active_os s) i i0; crush.
    unfold madd_owner; crush.
    apply H19; crush.
    apply stealth_va_accessible.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    destruct H16 with (os_current_page x2) p0 stealth_va p1; crush.
    unfold osi_pa_to_pg; crush.
    rewrite get_add_mem_distinct in H19; auto.
    destruct H1 with pt_addr ma pg; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.

    (* New normal *)
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros.
    assert (exists pg, get_cache 
      (smem_c (st_memory (State (st_active_os s)
        (OSS.set (st_oss s) o {| os_hcall := None;
                                 os_current_page := os_current_page x1 |})
        (st_exec_mode s) (st_aos_activity s)
        (st_hypervisor s) (ACT.new s o x0 v x2)))) (stealth_va, ma) = 
                       Some pg).
    crush.
    rewrite STAC.madd_of_vadd_new_shared_distinct_va 
      with (osi:=o) in H17; auto.
    assert (aos_current_page_table s = Some pt_addr).
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    clear Heqopt_res.
    rewrite new_cache_shared; crush.
    rewrite get_remove_ma_cache_ne; crush.
    assert (exists pg, get_cache (smem_c (st_memory s)) (stealth_va, ma) =
      Some pg).
    STAC.destruct_valid_state.
    unfold madd_of_vadd, madd_page_table in H17; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p1 p2 
      stealth_va ma; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    destruct H_valid_currpg with (st_active_os s) i1 i2; crush.
    destruct H1 with pt_addr ma x; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    destruct H20.
    unfold remove_new_va_cache; crush.
    rewrite get_remove_cache_distinct with (pg:=x); crush.
    unfold non_stealth_ma in *; crush.
    specialize (H15 (os_current_page i) pt_addr).
    rewrite H17 in H15; crush.
    elim H15; crush.
    unfold osi_pa_to_ma, aos_current_page_table, 
      osi_current_page_table in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO (st_active_os s));
      crush.
    STAC.destruct_valid_state; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p1 p2 
      stealth_va ma; crush.
    destruct H_valid_currpg with (st_active_os s) i2 i3; crush.
    unfold madd_owner; crush.
    apply H22; crush.
    apply stealth_va_accessible; crush.
    crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2); crush.
    (* Not shared *)
    rewrite new_cache_not_shared; crush.
    rewrite STAC.madd_of_vadd_new_not_shared_distinct 
      with (osi:=o) in H17; auto.
    assert (aos_current_page_table s = Some pt_addr).
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    clear Heqopt_res.
    assert (exists pg, get_cache (smem_c (st_memory s)) (stealth_va, ma) =
      Some pg).
    STAC.destruct_valid_state.
    unfold madd_of_vadd, madd_page_table in H17; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p1 p2 
      stealth_va ma; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    destruct H_valid_currpg with (st_active_os s) i1 i2; crush.
    destruct H1 with pt_addr ma x; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    destruct H20.
    unfold remove_new_va_cache; crush.
    rewrite get_remove_cache_distinct with (pg:=x); crush.
    unfold non_stealth_ma in *; crush.

    assert (valid_state 
{| st_active_os := st_active_os s;
   st_oss := OSS.set (st_oss s) o
                     {|
                       os_hcall := None;
                       os_current_page := os_current_page x1 |};
   st_exec_mode := st_exec_mode s;
   st_aos_activity := st_aos_activity s;
   st_hypervisor := st_hypervisor s;
   st_memory := ACT.new s o x0 v x2 |}).
    apply valid_state_invariant_sm with s 
      (New_normal o v p); 
      unfold valid_sm_state, valid_sm_exec; crush.
    unfold pre_new_normal; crush.
    exists x2; crush.
    unfold pre_all_new; crush.
    unfold pre_new_normal; crush.
    exists x2; crush.
    unfold pre_all_new; crush.
    unfold ACT.post_new, ACT.post_all_new; crush.
    exists x2; exists x0; crush.
    unfold ACT.post_new, ACT.post_all_new; crush.
    exists x2; exists x0; crush.
    remember ({| st_active_os := st_active_os s;
   st_oss := OSS.set (st_oss s) o
                     {|
                       os_hcall := None;
                       os_current_page := os_current_page x1 |};
   st_exec_mode := st_exec_mode s;
   st_aos_activity := st_aos_activity s;
   st_hypervisor := st_hypervisor s;
   st_memory := ACT.new s o x0 v x2 |}) as s'.
    clear Heqs'.
    clear dependent s.
    destruct H19.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma x; crush.
    unfold is_rw_page in *; crush.
    exists x4; crush.
    rewrite H; crush.
    destruct x; crush.

    (* New sm *)
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros.
    assert (exists pg, get_cache 
      (smem_c (st_memory (State (st_active_os s)
        (OSS.set (st_oss s) o {| os_hcall := None;
                                 os_current_page := os_current_page x1 |})
        (st_exec_mode s) (st_aos_activity s)
        (st_hypervisor s) (new_sm s o x2 x0)))) (stealth_va, ma) = 
                       Some pg).
    crush.
    rewrite <- OSS.get_set in *; crush.
    destruct (madd_eq ma x0); crush.
    (* ma = x0 *)
    rewrite <- get_add_cache_cacheable; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va x0 p1; crush.
    (* ma <> x0 *)
    rewrite STAC.madd_of_vadd_new_not_shared_distinct_pt
      with (osi:=st_active_os s) in H19; crush.
    unfold osi_current_page_table in *; crush.
    rewrite STAC.madd_of_vadd_new_not_shared in H19; crush.
    unfold madd_type; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H24; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    (* o not active *)
    rewrite OSS.get_set_distinct in *; crush.
    rewrite STAC.madd_of_vadd_new_not_shared_distinct_pt 
      with (osi:=o) in H19; crush.
    rewrite new_cache_not_shared; crush.
    unfold remove_new_va_cache; crush.
    STAC.destruct_valid_state.
    unfold madd_of_vadd, madd_page_table in H19; crush.
    remember (page_content p1).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p1 p2 
      stealth_va ma; crush.
    destruct H_valid_currpg with (st_active_os s) i i0; crush.
    destruct H1 with pt_addr ma x; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    unfold osi_current_page_table in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = 
      Os_PO (st_active_os s)); crush.
    STAC.destruct_valid_state; crush.
    destruct H21.

    assert (valid_state 
{| st_active_os := st_active_os s;
   st_oss := OSS.set (st_oss s) o
                     {|
                       os_hcall := None;
                       os_current_page := os_current_page x1 |};
   st_exec_mode := st_exec_mode s;
   st_aos_activity := st_aos_activity s;
   st_hypervisor := st_hypervisor s;
   st_memory := new_sm s o x2 x0 |}).
    apply valid_state_invariant_sm with s 
      (New_sm o p); 
      unfold valid_sm_state, valid_sm_exec; crush.
    unfold pre_new_sm; crush.
    exists x2; crush.
    exists x0; exists x3; crush.
    unfold pre_all_new; crush.
    unfold pre_new_sm; crush.
    exists x2; crush.
    exists x0; exists x3; crush.
    unfold pre_all_new; crush.
    unfold pre_new_sm; crush.
    exists x2; crush.
    exists x0; exists x3; crush.
    unfold pre_all_new; crush.
    unfold post_new_sm; crush.
    exists x0; exists x2; crush.
    unfold post_new_sm; crush.
    exists x0; exists x2; crush.
    unfold post_new_sm; crush.
    exists x0; exists x2; crush.
    remember ({| st_active_os := st_active_os s;
   st_oss := OSS.set (st_oss s) o
                     {|
                       os_hcall := None;
                       os_current_page := os_current_page x1 |};
   st_exec_mode := st_exec_mode s;
   st_aos_activity := st_aos_activity s;
   st_hypervisor := st_hypervisor s;
   st_memory := new_sm s o x2 x0 |}) as s'.
    clear Heqs'.
    clear dependent s.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma x; crush.
    unfold is_rw_page in *; crush.
    exists x5; crush.
    rewrite H21; crush.
    destruct x; crush.

    (* Switch *)    
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    assert (exists stealth_pg_cache, 
              get_cache (smem_c (st_memory s')) (stealth_va, ma) = 
              Some stealth_pg_cache).
    assert (exists o_pt_addr, osi_current_page_table s o = Some o_pt_addr).
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    destruct H_valid_currpg with o x x0; crush.
    exists x1; crush.
    unfold osi_current_page_table; crush.
    destruct H9 as [o_pt_addr H_o_pt_addr].
    generalize (Hpost o_pt_addr H_o_pt_addr); clear Hpost; crush.
    unfold osi_current_page_table in *; crush.
    apply ctxt_switch_stealth_page_cached with o (os_current_page i);
      crush.
    unfold valid_sm_state; crush.
    unfold osi_pa_to_ma; crush.
    unfold madd_type; crush.
    rewrite madd_of_vadd_ctxt_switch_new_smem 
      with (osi:=o) (pt_padd':=(os_current_page i)) in H7; 
      unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    unfold osi_current_page_table; crush.
    rewrite madd_of_vadd_ctxt_switch_new_smem 
      with (osi:=o) (pt_padd':=(os_current_page i)) in H7; 
      unfold osi_pa_to_ma; crush.
    destruct H9.
    assert (valid_state s').
    apply valid_state_invariant_sm with s (Switch_sm o); 
      unfold valid_sm_state, valid_sm_exec; crush.
    clear dependent s.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma x; crush.
    unfold is_rw_page in *; crush.
    exists x1; crush.
    rewrite H9.
    destruct x; crush.

    (* Lswitch *)
    unfold stealth_page_cached, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    assert (exists stealth_pg_cache, 
              get_cache (smem_c (st_memory s')) (stealth_va, ma) = 
              Some stealth_pg_cache).
    unfold ACT.pre_lswitch in Hpre; crush.
    specialize (Hpost x H9); crush.
    apply ctxt_switch_stealth_page_cached with (st_active_os s) p; crush.
    unfold valid_sm_state; crush.
    rewrite madd_of_vadd_ctxt_switch_new_smem 
      with (osi:=st_active_os s) (pt_padd':=(os_current_page i)) in H7; 
      unfold osi_pa_to_ma; crush.
    rewrite <- OSS.get_set in *; crush.
    unfold osi_pa_to_ma in *; crush.
    rewrite <- OSS.get_set in *; crush.
    unfold osi_pa_to_ma in *; crush.
    destruct H9.
    assert (valid_state s').
    apply valid_state_invariant_sm with s 
      (LSwitch_untrusted_sm (st_active_os s) p); 
      unfold valid_sm_state, valid_sm_exec; crush.
    unfold post_sm_lswitch; crush.
    clear dependent s.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma x; crush.
    unfold is_rw_page in *; crush.
    exists x1; crush.
    rewrite H9.
    destruct x; crush.

    (* Lswitch not aos *)
    unfold ACT.pre_lswitch in Hpre; crush.
    specialize (Hpost x H0); crush.
    unfold stealth_page_cached; simpl.

    assert (aos_current_page_table 
      (State (st_active_os s) 
             (OSS.set (st_oss s) o 
                      {| os_hcall := None; os_current_page := p |})
             (st_exec_mode s) (st_aos_activity s) 
             (st_hypervisor s) (st_memory s)) =
      aos_current_page_table s).
    unfold aos_current_page_table, osi_current_page_table; crush.
    rewrite OSS.get_set_distinct; crush.
    rewrite H11; crush.
Qed.    

  Lemma all_read_no_stealth_page_inv : 
    forall s s' va,
      valid_sm_state s ->
      ACT.pre_all_read va s ->
      ACT.post_all_read va s s' ->
      no_stealth_page s'.
  Proof.
    unfold ACT.pre_all_read, ACT.post_all_read in *; crush;
      STAC.unify_read_post; crush.
    unfold no_stealth_page, aos_current_page_table,
      osi_current_page_table; crush.
    unfold valid_sm_state in *; crush.
    rewrite <- STAC.read_same_madd_of_vadd in H4; crush.
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite get_new_cache with (ma:=m) (pg:=x) (val:=x0); crush.
    remember (get_cache (fst (add_cache (smem_c (st_memory s)) (va, m) x))
      (stealth_va, ma)).
    destruct o; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (stealth_va,ma) x p); crush.
    rewrite H11; crush; clear H11.
    apply H6 with (pt_addr:=pt_addr); crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold madd_of_vadd_smem in *; crush.
    assert (madd_of_vadd (smem_mm  (st_memory s)) pt_addr stealth_va = Some m); crush.
    STAC.destruct_valid_state; crush.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    
    rewrite get_page_result with (pg:=x); crush.
    unfold page_of_vadd_smem; crush.
  Qed.

  Lemma all_write_no_stealth_page_inv : 
    forall s s' va val,
      valid_sm_state s ->
      ACT.pre_all_write va val s ->
      ACT.post_all_write va val s s' ->
      no_stealth_page s'.
  Proof.
    unfold valid_sm_state, ACT.pre_all_write, ACT.post_all_write in *; 
      crush; STAC.unify_write_post; crush.
    unfold no_stealth_page, aos_current_page_table,
      osi_current_page_table; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    crush.
    rewrite <- STAC.write_same_madd_of_vadd 
      with (old_pg:=x) (pt_page:=pt_page) in H10; crush.
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite set_new_cache with (ma:=m) (pg:=x) (old_val:=x0); crush.
    remember (get_cache (fst (add_cache (smem_c (st_memory s)) (va, m) 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x))))
      (stealth_va, ma)).
    destruct o; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (stealth_va,ma) 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x))
      p); crush.
    rewrite H11; crush; clear H11.
    apply H3 with (pt_addr:=pt_addr); crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd_smem in *; crush.
    assert (madd_of_vadd (smem_mm  (st_memory s)) pt_addr stealth_va = Some m); crush.
    STAC.destruct_valid_state; crush.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold page_of_vadd_smem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold is_pt_page; crush.
  Qed.

  Lemma pin_no_stealth_page_inv : 
    forall s s' o pa t,
      valid_sm_state s ->
      ACT.pre_pin o pa t s ->
      ACT.post_pin o pa t s s' ->
      no_stealth_page s'.
  Proof.
    unfold valid_sm_state, ACT.pre_pin; crush.
    unfold ACT.post_pin in *.
    remember (new_page (Some t) (Os_PO o)).
    clear Heqp; crush.
    unfold no_stealth_page, aos_current_page_table, osi_current_page_table; 
      crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (madd_eq x1 pt_addr); crush.
    (* x = pt_addr *)
    rewrite <- get_add_mem in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = 
      Os_PO (st_active_os s)); crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq pa (os_current_page x3)); crush.
    rewrite <- P2M.get_set in *; crush.
    unfold osi_pa_to_ma in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite P2M.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    unfold madd_owner in *; crush.
    (* x <> pt_addr *)
    rewrite get_add_mem_distinct in *; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq pa (os_current_page x3)); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H25 in *; crush.
    apply H6 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H25; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H25 in *; crush.
    apply H6 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H25; crush.
  Qed.

  Lemma ctxt_switch_no_stealth_page_inv : 
    forall s o pt_padd pt_addr ma,
      valid_sm_state s ->
      osi_pa_to_ma s o pt_padd = Some pt_addr ->
      madd_type (smem_mm (st_memory s)) pt_addr = Some PT ->
      madd_of_vadd (smem_mm (ctxt_switch_new_smem s pt_addr)) 
                   pt_addr stealth_va = None ->
      get_cache (smem_c (ctxt_switch_new_smem s pt_addr)) 
                (stealth_va, ma) = None.
  Proof.
    unfold valid_sm_state; crush.
    unfold ctxt_switch_new_smem; crush.
    rewrite madd_of_vadd_ctxt_switch_new_smem
      with (osi:=o) (pt_padd':=pt_padd) in H2; crush.
    unfold remove_osi_stealth_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    rename m into aos_pt_addr, p into aos_pt_page.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    crush.
    rewrite H12; crush.
    rewrite get_invalid; crush.
    rewrite flush_ma_cache; crush.
    rewrite ctxt_switch_cache; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_eq; crush.
    rewrite get_remove_ma_cache_ne; crush.
    remember (get_cache (smem_c (st_memory s)) (stealth_va, ma)).
    destruct o0; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr0 pt_page 
      pt stealth_va i; crush.
    destruct H3 with pt_addr0 i x; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H12; crush.
    elim n; crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    rewrite flush_ma_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite flush_ma_mem; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache; crush.
    unfold update_cache_entry; crush.
    rewrite get_add_mem_distinct; crush.
    unfold madd_type in *; crush.
    remember (page_content p).
    destruct c; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite <- Heqc in *; crush.
    rewrite H2; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i pt_addr p0; crush.
    destruct H_valid_cache with v pt_addr p0; crush.
    unfold is_rw_page in *; crush.
    unfold madd_type in *; crush.
    rewrite H17 in *; crush.
    remember (get_mem (smem_mm (st_memory s)) pt_addr).
    destruct o0; crush.
    remember (page_content p).
    destruct c; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite <- Heqc in *; crush.
    rewrite H2; crush.    
    rewrite get_invalid; crush.
    rewrite ctxt_switch_cache; crush.
    remember (get_cache (smem_c (st_memory s)) (stealth_va, ma)).
    destruct o0; crush.
    rewrite H4 with (pt_addr:=pt_addr0) in Heqo0; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H12; crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite ctxt_switch_mem; crush.
    remember (get_mem (smem_mm (st_memory s)) pt_addr).
    destruct o0; crush.
    remember (page_content p).
    destruct c; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite <- Heqc in *; crush.
    rewrite H2; crush.    

    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
  Qed.

  Lemma no_stealth_page_inv : 
    forall s s' a,
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      no_stealth_page s'.
  Proof.
    unfold valid_sm_state; crush.

    sm_action_induction a;
      destruct_sm_and_normal_action_sem; crush.

    (* Read *)
    apply all_read_no_stealth_page_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Read_hyper *)
    apply all_read_no_stealth_page_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Write *)
    apply all_write_no_stealth_page_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Write hyper *)
    apply all_write_no_stealth_page_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Del untrusted *)
    unfold no_stealth_page, aos_current_page_table,
      osi_current_page_table; intros; simpl in *.
    rewrite delete_cache with (ma:=x2); crush.
    destruct (eq_cache_key (stealth_va,ma) (v,x2)); crush.
    rewrite get_remove_cache; crush.
    destruct (madd_eq x1 pt_addr); crush.
    (* x1 = pt_addr *)
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = 
      Os_PO (st_active_os s)).
    STAC.destruct_valid_state; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    unfold osi_current_page_table in *; crush.
    rewrite H15 in H16; injection H16; crush; clear H16.
    rewrite <- OSS.get_set in *; crush.
    remember (get_cache (remove_cache (smem_c (st_memory s)) 
                                      (v,x2)) (stealth_va, ma)).
    destruct o; crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma) (v,x2) p); crush.
    rewrite <- H16; crush; clear H16.
    destruct (vadd_eq v stealth_va); crush.
    remember (get_cache (smem_c (st_memory s)) (stealth_va, ma)).
    destruct o; crush.
    assert (exists pg, get_cache (smem_c (st_memory s)) (stealth_va, x2) = 
     Some pg).
    STAC.destruct_valid_state.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p2).
    destruct c; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr p2 p3 
      stealth_va x2; crush.
    unfold madd_owner in *; crush.
    destruct H1 with pt_addr x2 x; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    destruct H16.
    destruct (madd_eq ma x2); crush.
    elim n0.
    apply H4 with (pg:=p0) (pg':=x); crush.
    (* v <> stealth_va *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = None);
      crush.
    remember (get_cache (smem_c (st_memory s)) (v,x2)).
    destruct o.
    remember (remove_page_table_entry (smem_mm (st_memory s)) pt_addr v).
    destruct o; crush.
    rewrite delete_mem_some_entry with (mm':= m) (ma:=x2) (pg:=p0) in H14; 
      crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    destruct (madd_eq x2 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p0; crush.
    unfold is_rw_page in *; crush.
    destruct H_valid_currpg with (st_active_os s) x0 i0; crush.
    unfold is_pt_page in *; crush.
    rewrite get_add_mem_distinct in H14; crush.
    unfold remove_page_table_entry in Heqo1; crush.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p1).
    destruct c; crush.
    rewrite <- get_add_mem in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    remember (PT.get p3 stealth_va).
    destruct o; crush.
    rewrite PT.get_remove_distinct with (inf:=i) in H14; crush.
    rewrite delete_mem_invalid in H14; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) pt_addr v).
    destruct o; crush.
    rewrite delete_mem_no_entry with (mm':= m) (ma:=x2) in H14; 
      crush.
    unfold remove_page_table_entry in *; crush.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p0).
    destruct c; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite <- get_add_mem in *; crush.
    rewrite <- Heqc; crush.
    remember (PT.get p2 stealth_va).
    destruct o; crush.
    rewrite PT.get_remove_distinct with (inf:=i) in H14; crush.
    rewrite delete_mem_invalid in H14; crush.
    (* x1 <> pt_addr *)
    remember (get_cache (remove_cache (smem_c (st_memory s)) 
                                      (v,x2)) (stealth_va, ma)).
    destruct o0; crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma) (v,x2) p); crush.
    rewrite <- H15; crush; clear H15.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = None);
      crush.
    remember (get_cache (smem_c (st_memory s)) (v,x2)).
    destruct o0.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    rewrite delete_mem_some_entry with (mm':= m) (ma:=x2) (pg:=p0) in H14; 
      crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    destruct (madd_eq x2 pt_addr); crush.
    (* x2 = pt_addr *)
    rewrite <- get_add_mem in *; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p0; crush.
    unfold is_rw_page in *; crush.
    destruct H_valid_currpg with (st_active_os s) x0 i0; crush.
    unfold is_pt_page in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p0; crush.
    unfold is_rw_page in *; crush.
    destruct H_valid_currpg with (st_active_os s) i i0; crush.
    unfold is_pt_page in *; crush.
    (* x2 <> pt_addr *)
    rewrite get_add_mem_distinct in H14; crush.
    unfold remove_page_table_entry in Heqo2; crush.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p1).
    destruct c; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in H14; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    rewrite delete_mem_no_entry with (mm':= m) (ma:=x2) in H14; 
      crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    unfold remove_page_table_entry in Heqo2; crush.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p0).
    destruct c; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in H14; crush.

    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.

    (* Hcall *)
    unfold no_stealth_page; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    rewrite <- OSS.get_set in *; crush.
    apply H2 with (pt_addr:=pt_addr) ; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.

    (* Page pin *)
    apply pin_no_stealth_page_inv with (s:=s) (o:=o) (pa:=p) (t:=PT);
      crush; unfold valid_sm_state, ACT.pre_pin; crush.
    exists x; crush.
    unfold ACT.post_pin; crush.
    exists x; crush.
    apply pin_no_stealth_page_inv with (s:=s) (o:=o) (pa:=p) (t:=RW);
      crush; unfold valid_sm_state, ACT.pre_pin; crush.
    exists x; crush.
    unfold ACT.post_pin; crush.
    exists x; crush.

    (* Page unpin *)
    unfold no_stealth_page, aos_current_page_table, osi_current_page_table; 
      crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (madd_eq x0 pt_addr); crush.
    (* x0 = pt_addr *)
    rewrite <- get_add_mem in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = 
      Os_PO (st_active_os s)); crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    assert (P2M.get x (os_current_page x2) = Some pt_addr); crush.
    apply P2M.get_remove_old with (k':=p); crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO o); 
      crush.
    STAC.destruct_valid_state; crush.
    rewrite H19 in H20; injection H20; crush; clear H20.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    assert (P2M.get x (os_current_page x2) = Some pt_addr); crush.
    apply P2M.get_remove_old with (k':=p); crush.
    elim H12; crush.
    STAC.destruct_valid_state; crush.
    (* x0 <> pt_addr *)
    rewrite get_add_mem_distinct in *; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite <- HYP.get_set in *; crush.
    assert (P2M.get x (os_current_page x2) = Some pt_addr); crush.
    apply P2M.get_remove_old with (k':=p); crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H23 in *; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H23; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite HYP.get_set_distinct in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H22 in *; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H22; crush.

    (* New normal *)
    unfold no_stealth_page, aos_current_page_table,
      osi_current_page_table; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = None);
      crush.
    destruct (vadd_eq v stealth_va); crush.
    rewrite STAC.madd_of_vadd_new_shared_distinct_va 
      with (osi:=o) in H17; crush.
    unfold madd_type in *; crush.
    remember (get_mem (smem_mm (st_memory s)) x2).
    destruct o0; crush.
    rewrite new_cache_shared; crush.
    destruct (madd_eq x2 ma); crush.
    rewrite get_remove_ma_cache_eq; crush.
    rewrite get_remove_ma_cache_ne; crush.
    unfold remove_new_va_cache; crush.
    remember (get_cache (remove_cache (smem_c (st_memory s)) (v,m)) 
             (stealth_va,ma)).
    destruct o0; crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma) = Some p1); 
      crush.
    apply get_remove_cache_old with (k':=(v,m)); crush.
    rewrite <- H19.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    (* Not shared *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = None);
      crush.
    destruct (vadd_eq v stealth_va); crush.
    rewrite STAC.madd_of_vadd_new_not_shared_distinct 
      with (osi:=o) in H17; crush.
    rewrite new_cache_not_shared; crush.
    unfold remove_new_va_cache; crush.
    remember (get_cache (remove_cache (smem_c (st_memory s)) (v,m)) 
             (stealth_va,ma)).
    destruct o0; crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma) = Some p1); 
      crush.
    apply get_remove_cache_old with (k':=(v,m)); crush.
    rewrite <- H19.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (os_ident_eq o (st_active_os s)); crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite OSS.get_set_distinct in *; crush.

    (* New sm *)
    unfold no_stealth_page, aos_current_page_table,
      osi_current_page_table; crush.
    unfold osi_current_page_table in *; crush.
    rewrite <- OSS.get_set in *; crush.
    rewrite STAC.madd_of_vadd_new_not_shared in H19; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    unfold madd_type; crush.
    rewrite H22; crush.
    rewrite <- OSS.get_set in *; crush.
    unfold osi_current_page_table in *; crush.
    rewrite STAC.madd_of_vadd_new_not_shared in H19; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    unfold madd_type; crush.
    rewrite H22; crush.
    rewrite OSS.get_set_distinct in *; crush.
    rewrite STAC.madd_of_vadd_new_not_shared_distinct_pt 
      with (osi:=o) in H19; crush.
    rewrite new_cache_not_shared; crush.
    unfold remove_new_va_cache; crush.
    apply H2 with pt_addr; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    rewrite STAC.madd_of_vadd_new_not_shared in H19; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    unfold madd_type; crush.
    rewrite H23; crush.
    
    (* Switch *)
    unfold no_stealth_page, aos_current_page_table, osi_current_page_table;
      crush.
    unfold ACT.pre_switch in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    assert (osi_current_page_table s o = Some pt_addr0); crush.
    unfold osi_current_page_table; crush.
    specialize (Hpost pt_addr0 H14); crush.
    apply ctxt_switch_no_stealth_page_inv with o (os_current_page x); crush.
    unfold valid_sm_state; crush.
    unfold osi_pa_to_ma; crush.
    unfold madd_type; crush.
    rewrite H15; crush.

    (* LSwitch *)
    unfold no_stealth_page, aos_current_page_table, osi_current_page_table;
      crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
    apply ctxt_switch_no_stealth_page_inv with (st_active_os s) p; crush.
    unfold valid_sm_state; crush.
    rewrite <- OSS.get_set in *; crush.
    unfold osi_pa_to_ma in *; crush.
    unfold no_stealth_page, aos_current_page_table, osi_current_page_table;
      crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
    rewrite OSS.get_set_distinct in *; crush.
    apply H2 with (pt_addr:=pt_addr); crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
  Qed.
    
  Lemma all_read_stealth_page_reserved_inv : 
    forall s s' va,
      valid_sm_state s ->
      ACT.pre_all_read va s ->
      ACT.post_all_read va s s' ->
      stealth_page_reserved_line s'.
  Proof.
    unfold ACT.pre_all_read, ACT.post_all_read in *; crush;
      STAC.unify_read_post; crush.
    unfold stealth_page_reserved_line; crush.
    unfold aos_page_of_vadd_smem in *; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold valid_sm_state in *; crush.
    clear H3.
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite get_new_cache with (ma:=m) (pg:=x) (val:=x0) in H4; crush.
    2:rewrite get_page_result with (pg:=x); unfold page_of_vadd_smem; crush.
    destruct (eq_cache_key (va,m) (va0,ma)); crush.
    remember (page_cacheable x).
    destruct b; crush.
    rewrite <- get_add_cache_cacheable in *; crush.
    apply H10 with pt_addr0 ma; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    rewrite <- get_add_cache_non_cacheable in H4; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (va0,ma) x pg); crush.
  Qed.

  Lemma all_write_stealth_page_reserved_inv : 
    forall s s' va val,
      valid_sm_state s ->
      ACT.pre_all_write va val s ->
      ACT.post_all_write va val s s' ->
      stealth_page_reserved_line s'.
  Proof.
    unfold ACT.pre_all_write, ACT.post_all_write in *; crush;
      STAC.unify_write_post; crush.
    clear H3.
    unfold stealth_page_reserved_line; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold valid_sm_state in *; crush.
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite set_new_cache with (ma:=m) (pg:=x) (old_val:=x0) in H3; crush.
    2:unfold page_of_vadd_smem; crush.
    destruct (eq_cache_key (va,m) (va0,ma)); crush.
    remember (page_cacheable x).
    destruct b; crush.
    rewrite <- get_add_cache_cacheable in *; crush.
    apply H9 with pt_addr0 ma; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold is_cacheable; crush.
    rewrite <- get_add_cache_non_cacheable in H3; crush.
    unfold is_cacheable in *; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (va0,ma) 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x))
      pg); crush.
  Qed.

  Lemma ctxt_switch_stealth_page_reserved_inv : 
    forall s o pt_padd pt_addr va ma pg,
      valid_sm_state s ->
      osi_pa_to_ma s o pt_padd = Some pt_addr ->
      madd_type (smem_mm (st_memory s)) pt_addr = Some PT ->

      get_line va = get_line stealth_va ->
      get_cache (smem_c (ctxt_switch_new_smem s pt_addr)) 
                (va, ma) = Some pg ->
      va = stealth_va.
  Proof.
    unfold valid_sm_state, ctxt_switch_new_smem; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    remember (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va).
    destruct o0; crush.
    remember (page_of_vadd_madd_smem (st_memory s) stealth_va m0). 
    destruct o0; crush.
    destruct H8 with pt_addr m0 p; crush.
    unfold is_rw_page in *; crush.
    rewrite get_new_cache with (ma:=m0) (pg:=p) (val:=x) in H3; crush.
    destruct (eq_cache_key (stealth_va, m0) (va,ma)); crush.
    specialize (get_add_cache_distinct_not_new
      (smem_c (remove_osi_stealth_page (ctxt_switch (st_memory s)) m))
      (stealth_va,m0) (va,ma) p pg); crush.
    clear H3 H12 Heqval0 o0.
    unfold remove_osi_stealth_page in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H14 in *; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold madd_of_vadd_smem; crush.
    unfold remove_osi_stealth_page in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H15 in *; crush.
    rewrite flush_ma_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    unfold remove_osi_stealth_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H15; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i pt_addr p2; crush.
    destruct H_valid_cache with v pt_addr p2; crush.
    unfold madd_type, is_rw_page in *; crush.
    rewrite H18 in *; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite get_page_result with (pg:=p); crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    unfold remove_osi_stealth_page in *; crush.
    remember (page_content p0).
    destruct c; crush;
      try (rewrite ctxt_switch_tlb in *; rewrite get_empty_tlb in *); crush.
    rewrite flush_ma_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    unfold remove_osi_stealth_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H15; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_mem; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    unfold page_of_vadd_madd_smem; crush.
    rewrite flush_ma_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct (madd_eq m0 i); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.    
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite flush_ma_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i m1 p2; crush.
    destruct (madd_eq m1 m0); crush.
    rewrite <- get_add_mem; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct (vadd_eq stealth_va v); crush.
    remember (page_content p3).
    destruct c; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) m stealth_va = Some m0).
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H15; crush.
    STAC.synonym_cached.
    destruct (vadd_eq stealth_va v); crush.
    remember (page_content p3).
    destruct c; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) m stealth_va = Some m0).
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H15; crush.
    STAC.synonym_cached.
    rewrite get_add_mem_distinct; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i pt_addr p2; crush.
    destruct H_valid_cache with v pt_addr p2; crush.
    unfold madd_type, is_rw_page in *; crush.
    rewrite H18 in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    unfold page_of_vadd_madd_smem; crush.
    rewrite flush_ma_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct (madd_eq i m0); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    rewrite flush_ma_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct (madd_eq i m0); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite get_remove_ma_cache_no_entry in Heqval6; crush. 
    rewrite get_remove_ma_cache_ne in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_mem; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct H_valid_virtmap with o pt_addr p0 p1 stealth_va m0; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO o); crush.
    unfold osi_pa_to_ma in *; crush.
    unfold madd_owner in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.

    unfold madd_of_vadd, madd_page_table, madd_type in *; crush.
    remember (page_content p).
    destruct c; crush.
    rewrite get_invalid in *; crush.
    unfold remove_osi_stealth_page in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H12 in *; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold remove_osi_stealth_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H12; crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    rewrite flush_ma_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i pt_addr p3; crush.
    destruct H_valid_cache with v pt_addr p3; crush.
    unfold is_rw_page in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
  Qed.


  Lemma stealth_page_reserved_line_inv :
    forall s s' a,
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      stealth_page_reserved_line s'.
  Proof.
    unfold valid_sm_state; crush.

    sm_action_induction a;
      destruct_sm_and_normal_action_sem; crush.

    (* Read *)
    apply all_read_stealth_page_reserved_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Read_hyper *)
    apply all_read_stealth_page_reserved_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Write *)
    apply all_write_stealth_page_reserved_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Write hyper *)
    apply all_write_stealth_page_reserved_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Del untrusted *)
    unfold stealth_page_reserved_line; crush.
    rewrite delete_cache with (ma:=x2) in *; crush.
    destruct (eq_cache_key (va,ma) (v,x2)); crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (va,ma) (v,x2) pg); crush.

    (* New normal *)
    unfold stealth_page_reserved_line; crush.
    rewrite new_cache_shared in *; crush.
    destruct (madd_eq x2 ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    unfold remove_new_va_cache in *; crush.
    destruct (eq_cache_key (v,m) (va,ma)); crush.
    remember (get_cache (smem_c (st_memory s)) (va,ma)).
    destruct o0; crush.
    assert (get_cache (smem_c (st_memory s)) (va,ma) = Some pg); 
      crush.
    apply get_remove_cache_old with (k':=(v,m)); crush.
    (* Not shared *)
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.
    destruct (eq_cache_key (v,m) (va,ma)); crush.
    remember (get_cache (smem_c (st_memory s)) (va,ma)).
    destruct o0; crush.
    assert (get_cache (smem_c (st_memory s)) (va,ma) = Some pg); 
      crush.
    apply get_remove_cache_old with (k':=(v,m)); crush.

    (* New sm *)
    unfold stealth_page_reserved_line; crush.
    destruct (eq_cache_key (stealth_va, x0) (va,ma)); crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,x0) (va,ma) p0 pg); crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.

    (* Switch *)
    unfold stealth_page_reserved_line; crush.
    unfold ACT.pre_switch in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    assert (osi_current_page_table s o = Some pt_addr); crush.
    unfold osi_current_page_table; crush.
    specialize (Hpost pt_addr H14); crush.
    apply ctxt_switch_stealth_page_reserved_inv 
      with s o (os_current_page x) pt_addr ma pg; crush.
    unfold valid_sm_state; crush.
    unfold osi_pa_to_ma; crush.
    unfold madd_type; crush.
    rewrite H15; crush.

    (* LSwitch *)
    unfold stealth_page_reserved_line; crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
    apply ctxt_switch_stealth_page_reserved_inv 
      with s (st_active_os s) p x ma pg; crush.
    unfold valid_sm_state; crush.
    unfold stealth_page_reserved_line; crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
  Qed.
    
  Lemma all_read_stealth_page_unique_inv : 
    forall s s' va,
      valid_sm_state s ->
      ACT.pre_all_read va s ->
      ACT.post_all_read va s s' ->
      stealth_page_unique s'.
  Proof.
    unfold ACT.pre_all_read, ACT.post_all_read in *; crush;
      STAC.unify_read_post; crush.
    unfold stealth_page_unique; crush.
    clear H3.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold valid_sm_state in *; crush.
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite get_new_cache with (ma:=m) (pg:=x) (val:=x0) in *; crush;
      try rewrite get_page_result with (pg:=x); crush;
      unfold page_of_vadd_smem; crush.
    destruct (eq_cache_key (va,m) (stealth_va,ma)); crush.
    remember (page_cacheable x).
    destruct b; crush.
    rewrite <- get_add_cache_cacheable in *; crush.
    destruct (madd_eq ma ma'); crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,ma) (stealth_va,ma') pg pg'); crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma') =Some pg');
      crush.
    rewrite H1; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H3 with pt_addr0 ma pg; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    rewrite <- get_add_cache_non_cacheable in *; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (stealth_va,ma) x pg); crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma) =Some pg);
      crush.
    destruct (eq_cache_key (va,m) (stealth_va,ma')); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H3 with pt_addr0 ma' x; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (stealth_va,ma') x pg'); crush.
  Qed.

  Lemma all_write_stealth_page_unique_inv : 
    forall s s' va val,
      valid_sm_state s ->
      ACT.pre_all_write va val s ->
      ACT.post_all_write va val s s' ->
      stealth_page_unique s'.
  Proof.
    unfold ACT.pre_all_write, ACT.post_all_write in *; crush;
      STAC.unify_write_post; crush.
    clear H3.
    unfold stealth_page_unique; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold valid_sm_state in *; crush.
    unfold page_of_vadd_smem in *; crush.
    unfold is_rw_page in *; crush.
    rewrite set_new_cache with (ma:=m) (pg:=x) (old_val:=x0) in *; crush;
      try rewrite set_page_result with (pg:=x); crush;
      unfold page_of_vadd_smem; crush.
    destruct (eq_cache_key (va,m) (stealth_va,ma)); crush.
    remember (page_cacheable x).
    destruct b; crush.
    rewrite <- get_add_cache_cacheable in *; crush.
    destruct (madd_eq ma ma'); crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,ma) (stealth_va,ma') 
      (Page (RW_c (Some val)) (page_owned_by x) true)
      pg'); crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma') =Some pg');
      crush.
    rewrite H1; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H4 with pt_addr0 ma x; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold is_cacheable; crush.
    rewrite <- get_add_cache_non_cacheable in *; crush;
      unfold is_cacheable in *; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (stealth_va,ma) 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x))
      pg); crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma) =Some pg);
      crush.
    destruct (eq_cache_key (va,m) (stealth_va,ma')); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H4 with pt_addr0 ma' x; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd_smem in *; crush.
    STAC.destruct_valid_state.
    apply H_valid_tlb; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (va,m) (stealth_va,ma') 
      (Page (RW_c (Some val)) (page_owned_by x) (page_cacheable x))
      pg'); crush.
  Qed.

  Lemma ctxt_switch_stealth_page_unique_inv : 
    forall s o pt_padd pt_addr ma ma' pg pg',
      valid_sm_state s ->
      osi_pa_to_ma s o pt_padd = Some pt_addr ->
      madd_type (smem_mm (st_memory s)) pt_addr = Some PT ->

      get_cache (smem_c (ctxt_switch_new_smem s pt_addr)) 
                (stealth_va, ma) = Some pg ->
      get_cache (smem_c (ctxt_switch_new_smem s pt_addr)) 
                (stealth_va, ma') = Some pg' ->
      ma = ma'.
  Proof.
    unfold valid_sm_state, ctxt_switch_new_smem; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    remember (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va).
    destruct o0; crush.
    assert (madd_of_vadd_smem 
      (remove_osi_stealth_page (ctxt_switch (st_memory s)) m) 
      pt_addr stealth_va = Some m0).
    unfold remove_osi_stealth_page; crush.
    remember (page_content p).
    destruct c; crush;
      unfold madd_of_vadd_smem; crush;
      try (rewrite flush_ma_tlb in *; crush);
      try (rewrite ctxt_switch_tlb in *; crush; 
           rewrite get_empty_tlb in *; crush);
      try rewrite ctxt_switch_mem; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i1 pt_addr p2; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p2; crush.
    unfold is_rw_page in *; crush.
    rewrite H13 in *; crush.
    rewrite ctxt_switch_mem; crush.
    unfold madd_of_vadd_smem; crush;
      try (rewrite ctxt_switch_tlb in *; crush; 
           rewrite get_empty_tlb in *; crush);
      try rewrite ctxt_switch_mem; crush.
    remember (page_of_vadd_madd_smem (st_memory s) stealth_va m0). 
    destruct o0; crush.

    assert (page_of_vadd_smem 
      (remove_osi_stealth_page (ctxt_switch (st_memory s)) m) 
      pt_addr stealth_va = Some p).
    unfold page_of_vadd_smem; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold remove_osi_stealth_page in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H14 in *; crush.
    rewrite flush_ma_cache in Heqval0; crush.
    destruct (madd_eq i m0); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold remove_osi_stealth_page in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H14 in *; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i m0); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    destruct (madd_eq m1 m0); crush.
    rewrite <- get_add_mem; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v m0 m0 p2; crush.
    destruct (vadd_eq stealth_va v); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    symmetry in Heqo0.
    STAC.synonym_cached.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v m0 m1 p2; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite get_remove_ma_cache_no_entry in Heqval4; crush. 
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    destruct (madd_eq m1 m0); crush.
    rewrite <- get_add_mem; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i m0 p2; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i m1 p2; crush.
    rewrite get_add_mem_distinct; crush.
    destruct (vadd_eq stealth_va v); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    elim n0; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.

    destruct H8 with pt_addr m0 p; crush.
    unfold is_rw_page in *; crush.
    rewrite get_new_cache with (ma:=m0) (pg:=p) (val:=x) in *; crush;
      try rewrite get_page_result with (pg:=p); crush;
      unfold page_of_vadd_smem; crush.
    destruct (eq_cache_key (stealth_va, m0) (stealth_va,ma)); crush.
    rewrite <- get_add_cache_cacheable in *; crush.
    unfold page_of_vadd_madd_smem in Heqo1; crush.
    destruct (madd_eq ma ma'); crush.
    assert (get_cache 
      (smem_c (remove_osi_stealth_page (ctxt_switch (st_memory s)) m))
      (stealth_va,ma') = Some pg').
    specialize (get_add_cache_distinct_not_new 
      (smem_c (remove_osi_stealth_page (ctxt_switch (st_memory s)) m))
      (stealth_va,ma) (stealth_va,ma') p pg'); crush.
    rewrite H2; crush.
    clear H3.
    unfold remove_osi_stealth_page in H2; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H16 in *; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i ma'); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    unfold remove_osi_stealth_page in H3; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H16 in *; crush.
    destruct (madd_eq ma ma'); crush.
    assert (get_cache 
      (smem_c (flush_ma (ctxt_switch (st_memory s)) i))
      (stealth_va,ma') = Some pg').
    specialize (get_add_cache_distinct_not_new 
      (smem_c (flush_ma (ctxt_switch (st_memory s)) i))
      (stealth_va,ma) (stealth_va,ma') pg pg'); crush.
    rewrite H2; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i ma'); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct H_valid_virtmap with (st_active_os s) m p pt stealth_va i; 
      crush.
    destruct H4 with m i x0; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H16; crush.
    elim n0; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct (madd_eq ma ma'); crush.
    assert (get_cache (smem_c (st_memory s)) (stealth_va,ma') = Some pg').
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,ma) (stealth_va,ma') pg pg'); crush.
    rewrite H2; crush.
    rewrite H5 with (pt_addr:=m) in H2; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H16; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite ctxt_switch_mem in *; crush.
    (* m0 <> ma *)
    assert (get_cache 
      (smem_c (remove_osi_stealth_page (ctxt_switch (st_memory s)) m))
      (stealth_va,ma) = Some pg).
    specialize (get_add_cache_distinct_not_new 
      (smem_c (remove_osi_stealth_page (ctxt_switch (st_memory s)) m))
      (stealth_va,m0) (stealth_va,ma) p pg); crush.
    unfold remove_osi_stealth_page in H14; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H18 in *; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq ma i); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct H_valid_virtmap with (st_active_os s) m p0 pt stealth_va i; 
      crush.
    destruct H4 with m i x0; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H18; crush.
    elim n0; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite H5 with (pt_addr:=m) in H14; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H18; crush.
    rewrite ctxt_switch_mem, ctxt_switch_cache in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    
    unfold page_of_vadd_madd_smem in *; crush.
    unfold osi_pa_to_ma in *; crush.
    unfold madd_of_vadd, madd_page_table in Heqo0; crush.
    remember (page_content p0).
    destruct c; crush.
    STAC.destruct_valid_state.
    destruct H_valid_virtmap with o pt_addr p0 p1 stealth_va m0; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO o); crush.
    unfold madd_owner in *; crush.

    unfold madd_of_vadd, madd_page_table in *; crush.
    unfold madd_type in *; crush.
    remember (page_content p).
    destruct c; crush.
    assert (page_of_vadd_smem 
      (remove_osi_stealth_page (ctxt_switch (st_memory s)) m)
      pt_addr stealth_va = None).
    unfold page_of_vadd_smem; crush.
    unfold madd_of_vadd_smem; crush.
    unfold remove_osi_stealth_page in Heqval0; crush.
    remember (page_content p1).
    destruct c; crush; 
      try rewrite flush_ma_tlb in *; crush;
      try rewrite ctxt_switch_tlb in *; crush;
      try rewrite get_empty_tlb in *; crush.
    rewrite ctxt_switch_tlb in *; crush.
    rewrite get_empty_tlb in *; crush.
    clear Heqval0.
    unfold madd_of_vadd, madd_page_table; crush.
    unfold remove_osi_stealth_page at 2; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H12; crush.
    rewrite flush_ma_mem; crush.
    unfold update_cache_entry; crush;
      try rewrite ctxt_switch_mem; crush.
    rewrite get_add_mem_distinct; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    rewrite ctxt_switch_cache in *; crush.
    destruct get_remove_ma_cache_some_entry with (smem_c (st_memory s))
      v i pt_addr p3; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p3; crush.
    unfold is_rw_page in *; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    rewrite ctxt_switch_mem; crush.
    rewrite <- Heqc; crush.
    rewrite <- Heqo0; crush.
    
    rewrite get_invalid in *; crush.
    unfold remove_osi_stealth_page in *; crush.
    rewrite ctxt_switch_mem in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data; crush.
    STAC.get_aos_current_pt_page; crush.
    rewrite H13 in *; crush.
    rewrite flush_ma_cache in *; crush.
    destruct (madd_eq i ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite get_remove_ma_cache_eq in H3; crush.
    rewrite ctxt_switch_cache in *; crush.
    rewrite ctxt_switch_cache in *; crush.
  Qed.
    

  Lemma stealth_page_unique_inv :
    forall s s' a,
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      stealth_page_unique s'.
  Proof.
    unfold valid_sm_state; crush.

    sm_action_induction a;
      destruct_sm_and_normal_action_sem; crush.

    (* Read *)
    apply all_read_stealth_page_unique_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Read_hyper *)
    apply all_read_stealth_page_unique_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Write *)
    apply all_write_stealth_page_unique_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Write hyper *)
    apply all_write_stealth_page_unique_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Del untrusted *)
    unfold stealth_page_unique; crush.
    rewrite delete_cache with (ma:=x2) in *; crush.
    destruct (eq_cache_key (stealth_va,ma) (v,x2)); crush.
    rewrite get_remove_cache in H11; crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma) (v,x2) pg); crush.
    destruct (eq_cache_key (stealth_va,ma') (v,x2)); crush.
    rewrite get_remove_cache in H14; crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma') (v,x2) pg'); crush.

    (* New normal *)
    unfold stealth_page_unique; crush.
    rewrite new_cache_shared in *; crush.
    destruct (madd_eq x2 ma); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in H16; crush.
    destruct (madd_eq x2 ma'); crush.
    rewrite get_remove_ma_cache_eq in *; crush.
    rewrite get_remove_ma_cache_ne in *; crush.
    unfold remove_new_va_cache in *; crush.
    destruct (eq_cache_key (v,m) (stealth_va,ma)); crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma) (v,m) pg); crush.
    destruct (eq_cache_key (v,m) (stealth_va,ma')); crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma') (v,m) pg'); crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.
    destruct (eq_cache_key (v,m) (stealth_va,ma)); crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma) (v,m) pg); crush.
    destruct (eq_cache_key (v,m) (stealth_va,ma')); crush.
    specialize (get_remove_cache_old (smem_c (st_memory s))
      (stealth_va,ma') (v,m) pg'); crush.

    (* New sm *)
    unfold stealth_page_unique; crush.
    destruct (eq_cache_key (stealth_va, x0) (stealth_va,ma)); crush.
    destruct (eq_cache_key (stealth_va,ma) (stealth_va,ma')); crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,ma) (stealth_va,ma') p0 pg'); crush.
    rewrite H2 with (pt_addr:=x2) in n; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,x0) (stealth_va,ma) p0 pg); crush.
    rewrite H2 with (pt_addr:=x2) in n; crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.

    (* Switch *)
    unfold stealth_page_unique; crush.
    unfold ACT.pre_switch in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    assert (osi_current_page_table s o = Some pt_addr); crush.
    unfold osi_current_page_table; crush.
    specialize (Hpost pt_addr H14); crush.
    apply ctxt_switch_stealth_page_unique_inv
      with s o (os_current_page x) pt_addr pg pg'; crush.
    unfold valid_sm_state; crush.
    unfold osi_pa_to_ma; crush.
    unfold madd_type; crush.
    rewrite H15; crush.

    (* LSwitch *)
    unfold stealth_page_unique; crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
    apply ctxt_switch_stealth_page_unique_inv 
      with s (st_active_os s) p x pg pg'; crush.
    unfold valid_sm_state; crush.
    unfold stealth_page_unique; crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
  Qed.

  Lemma all_read_stealth_page_rw_cacheable_inv :
    forall s s' va,
      valid_sm_state s ->
      ACT.pre_all_read va s ->
      ACT.post_all_read va s s' ->
      stealth_page_rw_cacheable s'.
  Proof.
    unfold ACT.pre_all_read, ACT.post_all_read in *; crush;
      STAC.unify_read_post; crush.
    clear H3.
    unfold valid_sm_state, aos_current_page_table, osi_current_page_table in *; crush.
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    destruct H8.
    destruct H8.
    unfold osi_pa_to_ma in *; simpl in *.
    destruct H6 with pt_addr ma pg; crush.
    rewrite <- STAC.read_same_madd_of_vadd in H9; 
      unfold aos_current_page_table, osi_current_page_table; crush.
    unfold is_rw_page in *; crush.
    unfold page_of_vadd_smem in *; crush.
    rewrite <- STAC.read_same_mem with (ma':=m) (pt_addr:=pt_addr) (pg:=x) (val:=x2) in H10;
      crush.
    exists x0; exists x1; unfold osi_pa_to_ma; crush.
    exists (st_active_os s); exists (os_current_page i);
      unfold osi_pa_to_ma; crush.
    rewrite <- STAC.read_same_madd_of_vadd in H9; 
      unfold aos_current_page_table, osi_current_page_table; crush.
  Qed.

  Lemma all_write_stealth_page_rw_cacheable_inv :
    forall s s' va val,
      valid_sm_state s ->
      ACT.pre_all_write va val s ->
      ACT.post_all_write va val s s' ->
      stealth_page_rw_cacheable s'.
  Proof.
    unfold ACT.pre_all_write, ACT.post_all_write in *; crush;
      STAC.unify_write_post; crush.
    clear H3.
    unfold valid_sm_state, aos_current_page_table, osi_current_page_table in *; crush.
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    destruct H8.
    destruct H8.
    unfold osi_pa_to_ma in *; simpl in *.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = Some ma).
    unfold page_of_vadd_smem in *; crush.
    assert (madd_type (smem_mm (st_memory s)) pt_addr = Some PT).
    rewrite <- STAC.write_same_madd_type with (pt_addr:=pt_addr0) (va:=va) (val:=val); 
      crush.
    unfold madd_type, madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_type in *; crush.
    remember (page_content p).
    destruct c; crush.
    rewrite <- STAC.write_same_madd_of_vadd with (pt_page:=p) (old_pg:=x) in H9; 
      unfold aos_current_page_table, osi_current_page_table; crush.
    unfold aos_page_of_vadd_smem; crush.
    unfold page_of_vadd_smem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold is_pt_page; crush; rewrite H14; crush.
    unfold page_of_vadd_smem in *; simpl in *.
    remember (madd_of_vadd_smem (st_memory s) pt_addr0 va).
    destruct o; simpl in *; [|crush].

    destruct (madd_eq ma m); [subst|].
    assert (page_of_vadd_madd_smem (st_memory s) stealth_va m = Some x).
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr0 va = Some m).
    apply STAC.madd_of_vadd_smem_then_mmem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    destruct (vadd_eq va stealth_va); crush.
    unfold page_of_vadd_madd_smem; crush.
    symmetry in Heqval0.
    STAC.destruct_valid_state.
    STAC.synonym_cached.
    unfold page_of_vadd_madd_smem in H0; crush.
    symmetry in Heqval1.
    assert (stealth_va <> va); crush.
    STAC.destruct_valid_state.
    STAC.synonym_cached.

    rewrite STAC.write_smem_mem_eq with (pt_addr':=pt_addr) (old_pg:=x) in H10; crush.
    unfold is_rw_page in *; crush.
    unfold is_cacheable; simpl.
    destruct H6 with pt_addr m x; crush.
    exists x0; exists x1; crush.
    unfold osi_pa_to_ma; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    rewrite STAC.write_smem_mem_neq with (ma':=m) (pg:=x) (pt_addr:=pt_addr) in H10; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    apply STAC.madd_of_vadd_smem_then_mmem; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
  Qed.

  Lemma pin_stealth_page_rw_cacheable_inv : 
    forall s s' o pa t,
      valid_sm_state s ->
      ACT.pre_pin o pa t s ->
      ACT.post_pin o pa t s s' ->
      stealth_page_rw_cacheable s'.
  Proof.
    unfold valid_sm_state, ACT.pre_pin; crush.
    unfold ACT.post_pin in *; crush.
    unfold stealth_page_rw_cacheable; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    injection Heqc; crush.
    rewrite PT.get_empty in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct (madd_eq x1 ma); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite <- get_add_mem in *; crush.
    destruct H9 with pt_addr ma x4; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; unfold osi_pa_to_ma; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H9 with pt_addr ma pg; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; unfold osi_pa_to_ma; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.

    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    injection Heqc; crush.
    rewrite PT.get_empty in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct (madd_eq x1 ma); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite <- get_add_mem in *; crush.
    destruct H9 with pt_addr ma x4; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; unfold osi_pa_to_ma; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H9 with pt_addr ma pg; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; unfold osi_pa_to_ma; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.

    unfold stealth_page_rw_cacheable; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct (madd_eq x1 ma); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite <- get_add_mem in *; crush.
    destruct H9 with pt_addr ma x4; crush.
    unfold osi_pa_to_ma in *; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H9 with pt_addr ma pg; crush.
    unfold osi_pa_to_ma in *; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.

    unfold stealth_page_rw_cacheable; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct (madd_eq x1 ma); crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite <- get_add_mem in *; crush.
    destruct H9 with pt_addr ma x4; crush.
    unfold osi_pa_to_ma in *; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with stealth_va ma pg; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H9 with pt_addr ma pg; crush.
    unfold osi_pa_to_ma in *; crush.
    destruct (os_ident_eq x5 o); crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq x6 pa); crush.
    rewrite <- P2M.get_set in *; crush.
    rewrite P2M.get_set_distinct in *; crush.
    exists o; exists x6; crush.
    rewrite HYP.get_set_distinct in *; crush.
    exists x5; exists x6; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.
  Qed.

  Lemma ctxt_switch_stealth_page_rw_cacheable_inv : 
    forall s o pt_padd pt_addr pt_addr' ma pg,
      valid_sm_state s ->
      osi_pa_to_ma s o pt_padd = Some pt_addr ->
      (exists osi, exists pt_padd, osi_pa_to_ma s osi pt_padd = 
                                   Some pt_addr') ->
      madd_type (smem_mm (st_memory s)) pt_addr = Some PT ->

      madd_of_vadd (smem_mm (ctxt_switch_new_smem s pt_addr)) pt_addr' stealth_va = 
        Some ma ->
      page_of_vadd_madd_smem (ctxt_switch_new_smem s pt_addr) stealth_va ma = Some pg ->
      is_rw_page pg /\ is_cacheable pg.
  Proof.
    intros.
    rewrite madd_of_vadd_ctxt_switch_new_smem with 
      (osi:=o) (pt_padd':=pt_padd) in H3;
      try (unfold valid_sm_state in *; crush; fail).
    destruct H1; destruct H1.
    rewrite page_of_vadd_madd_smem_ctxt_switch_new_smem 
      with (osi:=o) (osi':=x) (pt_padd:=pt_padd) (pt_padd':=x0) 
                    (pt_addr':=pt_addr') in H4; 
      unfold valid_sm_state in *; crush.
  Qed.    

  Lemma stealth_page_rw_cacheable_inv :
    forall s s' a,
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      stealth_page_rw_cacheable s'.
  Proof.
    unfold valid_sm_state; crush.

    sm_action_induction a;
      destruct_sm_and_normal_action_sem; crush.

    (* Read *)
    apply all_read_stealth_page_rw_cacheable_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Read_hyper *)
    apply all_read_stealth_page_rw_cacheable_inv with (s:=s) (va:=v); crush;
      unfold valid_sm_state, ACT.pre_all_read; crush.

    (* Write *)
    apply all_write_stealth_page_rw_cacheable_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Write hyper *)
    apply all_write_stealth_page_rw_cacheable_inv with (s:=s) (va:=v) (val:=v0);
      crush; unfold valid_sm_state, ACT.pre_all_write; crush.

    (* Del untrusted *)
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = Some ma).
    remember (get_cache (smem_c (st_memory s)) (v, x2)).
    destruct o0; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    rewrite delete_mem_some_entry with (mm':=m) (ma:=x2) (pg:=p) in H14; 
      crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    destruct (madd_eq x2 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p; crush.
    unfold is_rw_page in *; crush.
    rewrite H16 in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    unfold remove_page_table_entry in *; crush.
    remember (page_content p2).
    destruct c; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (vadd_eq v stealth_va); crush.
    rewrite PT.get_remove in *; crush.
    rewrite <- Heqc; crush.
    apply PT.get_remove_old with (k':=v); crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in *; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    rewrite delete_mem_no_entry with (mm':=m) (ma:=x2) in H14; crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    unfold remove_page_table_entry in *; crush.
    remember (page_content p1).
    destruct c; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (vadd_eq v stealth_va); crush.
    rewrite PT.get_remove in *; crush.
    rewrite <- Heqc; crush.
    apply PT.get_remove_old with (k':=v); crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in *; crush.
    destruct H11; destruct H11.
    unfold osi_pa_to_ma in *; simpl in *.
    assert (page_of_vadd_madd_smem (st_memory s) stealth_va ma =
      Some pg); crush.
    unfold page_of_vadd_madd_smem in H15; crush.
    rewrite delete_cache with (ma:=x2) in Heqval; crush.
    destruct (eq_cache_key (v,x2) (stealth_va, ma)); crush.
    rewrite get_remove_cache in *; crush.
    unfold page_of_vadd_madd_smem; crush.
    rewrite get_remove_cache_old with (k':=(v,x2)) (pg:=pg) in Heqval0; crush.
    rewrite get_remove_cache_old with (k':=(v,x2)) (pg:=pg) in Heqval0; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct (eq_cache_key (v,x2) (stealth_va, ma)); crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 stealth_va).
    destruct o0; crush.
    rewrite delete_mem_some_entry with (mm':=m) (ma:=ma) (pg:=p) in H15; crush.
    rewrite <- get_add_mem in *; crush.
    unfold remove_page_table_entry in Heqo0; crush.
    unfold madd_of_vadd, madd_page_table in H13; crush.
    remember (page_content p1).
    destruct c; crush.
    rewrite delete_cache with (ma:=x2) in Heqval; crush.
    rewrite get_remove_cache_distinct with (pg:=p) in Heqval; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    remember (get_cache (smem_c (st_memory s)) (v,x2)).
    destruct o0; crush.
    rewrite delete_mem_some_entry with (mm':=m) (ma:=x2) (pg:=p) in H15; crush.
    unfold remove_page_table_entry in *; crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    remember (page_content p0).
    destruct c; crush.
    destruct (madd_eq x2 ma); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (vadd_eq stealth_va v); crush.
    symmetry in Heqo1.
    STAC.destruct_valid_state.
    STAC.synonym_cached.
    rewrite get_add_mem_distinct in *; crush.
    destruct (madd_eq x1 ma); crush.
    rewrite <- get_add_mem in *; crush.
    destruct H5 with pt_addr ma p0; crush.
    exists x; exists x3; unfold osi_pa_to_ma; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_no_entry with (mm':=m) (ma:=x2) in H15; crush.
    unfold remove_page_table_entry in *; crush.
    unfold madd_of_vadd, madd_page_table in H14; crush.
    remember (page_content p).
    destruct c; crush.
    destruct (madd_eq x1 ma); crush.
    rewrite <- get_add_mem in *; crush.
    destruct H5 with pt_addr ma p; crush.
    exists x; exists x3; unfold osi_pa_to_ma; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in *; crush.
    
    (* Page pin *)
    apply pin_stealth_page_rw_cacheable_inv with (s:=s) (o:=o) (pa:=p) 
      (t:=PT); crush; unfold valid_sm_state, ACT.pre_pin; crush.
    exists x; crush.
    unfold ACT.post_pin; crush.
    exists x; crush.
    apply pin_stealth_page_rw_cacheable_inv with (s:=s) (o:=o) (pa:=p) 
      (t:=RW); crush; unfold valid_sm_state, ACT.pre_pin; crush.
    exists x; crush.
    unfold ACT.post_pin; crush.
    exists x; crush.

    (* Page unpin *)
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    unfold page_of_vadd_madd_smem in *; crush;
      try (STAC.destruct_valid_state; destruct H_valid_cache with stealth_va ma pg; 
           crush; fail).
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p1).
    destruct c; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (osi_pa_to_ma s x1 x4 = Some pt_addr).
    destruct (os_ident_eq x1 o) eqn:?; crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq p x4) eqn:?; crush.
    rewrite P2M.get_remove in H17; crush.
    unfold osi_pa_to_ma; crush.
    rewrite P2M.get_remove_old with (k':=p) (inf:=pt_addr); crush.
    rewrite HYP.get_set_distinct in *; crush.
    unfold osi_pa_to_ma; crush.
    clear Heqopt_res; unfold osi_pa_to_ma in *; crush.
    destruct (madd_eq x3 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (madd_eq x3 ma); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in Heqopt_res0; crush.
    unfold ACT.no_va_mapped_to_ma in *.
    destruct H16 with x4 p1 stealth_va p2; crush.
    unfold osi_pa_to_pg; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO x1); crush.
    STAC.destruct_valid_state.
    destruct H_valid_virtmap with x1 pt_addr p1 p2 stealth_va ma; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO x1); crush.
    unfold madd_owner in *; crush.
    rewrite <- H21; crush.
    unfold madd_owner; crush.
    apply stealth_va_accessible; crush.
    rewrite H19 in H20; crush.
    injection H20; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H5 with pt_addr ma pg; crush.
    exists x1; exists x4; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.
    (* is_cacheble *)
    unfold madd_of_vadd, madd_page_table in *; crush.
    remember (page_content p1).
    destruct c; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (osi_pa_to_ma s x1 x4 = Some pt_addr).
    destruct (os_ident_eq x1 o) eqn:?; crush.
    rewrite <- HYP.get_set in *; crush.
    destruct (padd_eq p x4) eqn:?; crush.
    rewrite P2M.get_remove in H17; crush.
    unfold osi_pa_to_ma; crush.
    rewrite P2M.get_remove_old with (k':=p) (inf:=pt_addr); crush.
    rewrite HYP.get_set_distinct in *; crush.
    unfold osi_pa_to_ma; crush.
    clear Heqopt_res; unfold osi_pa_to_ma in *; crush.
    destruct (madd_eq x3 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (madd_eq x3 ma); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in Heqopt_res0; crush.
    unfold ACT.no_va_mapped_to_ma in *.
    destruct H16 with x4 p1 stealth_va p2; crush.
    unfold osi_pa_to_pg; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO x1); crush.
    STAC.destruct_valid_state.
    destruct H_valid_virtmap with x1 pt_addr p1 p2 stealth_va ma; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO x1); crush.
    unfold madd_owner in *; crush.
    rewrite <- H21; crush.
    unfold madd_owner; crush.
    apply stealth_va_accessible; crush.
    rewrite H19 in H20; crush.
    injection H20; crush.
    rewrite get_add_mem_distinct in *; crush.
    destruct H5 with pt_addr ma pg; crush.
    exists x1; exists x4; unfold osi_pa_to_ma; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite <- Heqc; crush.
    unfold page_of_vadd_madd_smem; crush.

    (* New normal *)
    Opaque ACT.new.
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    destruct H16.
    destruct H16.
    assert (osi_pa_to_ma s x x3 = Some pt_addr).
    unfold osi_pa_to_ma in *; crush.
    clear H16.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
      Some ma); [crush|].
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct (madd_eq x0 pt_addr); try subst.
    destruct (get_mem (smem_mm (st_memory s)) pt_addr) eqn:?; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold osi_current_page_table in *; crush.
    rewrite H23; crush.
    rewrite STAC.new_get_mem_pt_addr with (pt_page:=p0) (pt:=pt) 
      in Heqopt_res0; crush.
    injection Heqc; crush.
    rewrite PT.get_set_distinct in *; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO x); crush.
    STAC.destruct_valid_state; crush.
    unfold madd_owner in *; crush.
    rewrite STAC.new_get_mem_distinct_pt in Heqopt_res0; crush.
    rewrite Heqc; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    assert (madd_type (smem_mm (ACT.new s o x0 v x2)) pt_addr = Some PT); 
      crush.
    unfold madd_type; crush.
    rewrite Heqc; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; unfold osi_current_page_table in *; 
      crush.
    STAC.get_osi_current_pt_page o; crush.
    rewrite STAC.new_same_madd_type with (pt_page':=pt_page) (pt':=pt) 
      in H16; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    assert (page_of_vadd_madd_smem (st_memory s) stealth_va ma = Some pg).
    rewrite STAC.new_page_ne in H18; crush.
    (* New ma cannot be stealth *)
    destruct H15 with x3 pt_addr; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); crush.
    STAC.destruct_valid_state; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO x); crush.
    STAC.destruct_valid_state; crush.
    unfold madd_of_vadd, madd_page_table in H16; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct H_valid_virtmap with x pt_addr p1 p2 stealth_va ma; 
      crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO x); crush.
    unfold madd_owner in H21; crush.
    unfold madd_owner; crush.
    apply H22; apply stealth_va_accessible; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    destruct H5 with pt_addr ma pt_page; crush.
    unfold page_of_vadd_madd_smem; crush.
    destruct H_valid_cache with stealth_va ma p0; crush.
    unfold is_rw_page in *; crush.
    unfold is_rw_page in *; crush.
    unfold osi_current_page_table in *; crush.
    exists o; exists (os_current_page x1); unfold osi_pa_to_ma; crush.
    unfold madd_type; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold osi_current_page_table in *; crush.
    rewrite H24; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    destruct H5 with pt_addr ma pg; crush.

    (* New sm *)
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    destruct H18.
    destruct H18.
    assert (osi_pa_to_ma s x x4 = Some pt_addr).
    unfold osi_pa_to_ma in *; crush.
    clear H18.
    destruct (madd_eq x2 pt_addr); try subst.
    assert (pg = x3); crush.
    rewrite STAC.madd_of_vadd_new_not_shared in H19; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite H2 with (pt_addr:=pt_addr) in Heqval2; crush.
    rewrite <- get_add_cache_cacheable in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    rewrite H2 with (pt_addr:=pt_addr) in Heqval2; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    unfold is_rw_page in *; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    unfold is_rw_page in *; crush.
    rewrite new_cache_not_shared in Heqval0; crush.
    unfold remove_new_va_cache in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    destruct (PT.get pt stealth_va) eqn:?; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr0 pt_page 
      pt stealth_va i; crush.
    destruct H1 with (pt_addr:=pt_addr0) (ma:=i) (pg:=x0); crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H22; crush.
    assert (i = ma); crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO (st_active_os s));
      crush.
    unfold madd_owner; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO o); 
      unfold osi_pa_to_ma in *; crush.
    rewrite H2 with (pt_addr:=pt_addr0) in Heqval0; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H22; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold is_rw_page in *; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold madd_type; crush.
    rewrite H25; crush.
    (* x2 <> pt_addr *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr stealth_va = 
      Some ma).
    unfold madd_of_vadd, madd_page_table in *; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in Heqopt_res0; crush.
    clear H19.
    assert (page_of_vadd_madd_smem (st_memory s) stealth_va ma = Some pg);
      crush.
    unfold page_of_vadd_madd_smem; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page.
    destruct (PT.get pt stealth_va) eqn:?; crush.
    destruct H_valid_virtmap with (st_active_os s) pt_addr0 pt_page 
      pt stealth_va i; crush.
    destruct H1 with (pt_addr:=pt_addr0) (ma:=i) (pg:=x5); crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H24; crush.
    assert (i = ma); crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO (st_active_os s));
      crush.
    unfold madd_owner; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO x); 
      unfold osi_pa_to_ma in *; crush.
    unfold madd_of_vadd, madd_page_table in H18; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct H_valid_virtmap with x pt_addr p1 p2 stealth_va ma; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO x); crush.
    unfold madd_owner in *; crush.
    unfold madd_owner; crush.
    rewrite H32; crush.
    apply stealth_va_accessible.
    rewrite H32 in H31; injection H31; clear H31; crush.
    unfold page_of_vadd_madd_smem in *; crush;
      try (rewrite H2 with (pt_addr:=x2) in H30; crush; fail).
    rewrite new_cache_not_shared in Heqval0; crush.
    unfold remove_new_va_cache in *; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    rewrite new_cache_not_shared in Heqval0; crush.
    unfold remove_new_va_cache in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold osi_current_page_table, is_rw_page in *; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,x0) (stealth_va,ma) p1 pg); crush.
    rewrite <- H8 in Heqval; crush.
    clear H8.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO (st_active_os s));
      crush.
    unfold osi_pa_to_ma in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) ma = Os_PO x);
      crush.
    unfold osi_current_page_table in *; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p3) eqn:?; crush.
    destruct H_valid_virtmap with x pt_addr p3 p4 stealth_va ma; crush.
    unfold osi_pa_to_ma in *; crush.
    assert (madd_owner (smem_mm (st_memory s)) pt_addr = Os_PO x); crush.
    unfold osi_pa_to_ma in *; crush.
    unfold madd_owner in *; crush.
    unfold madd_owner; crush.
    rewrite H8 in H20; injection H20; crush; clear H20.
    unfold osi_pa_to_ma in *; crush.
    rewrite H2 with (pt_addr:=pt_addr0) in Heqval; crush.
    unfold aos_current_page_table, osi_current_page_table; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H24; crush.
    rewrite new_cache_not_shared in Heqval1; crush.
    unfold remove_new_va_cache in *; crush.
    rewrite H2 with (pt_addr:=pt_addr0) in Heqval; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H24; crush.
    rewrite H2 with (pt_addr:=pt_addr0) in Heqval; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H24; crush.
    rewrite H2 with (pt_addr:=pt_addr0) in Heqval; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H24; crush.
    rewrite H2 with (pt_addr:=pt_addr0) in Heqval; crush.
    unfold aos_current_page_table, osi_current_page_table in *; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    rewrite H24; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct (madd_eq x0 ma); crush.
    rewrite <- get_add_cache_cacheable in Heqval1; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    destruct H5 with pt_addr ma p0; crush.
    (* x0 <> ma *)
    specialize (get_add_cache_distinct_not_new (smem_c (st_memory s))
      (stealth_va,x0) (stealth_va,ma) p0 pg); crush.
    rewrite <- H19 in Heqval; crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    destruct H5 with pt_addr ma pt_page; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    STAC.get_aos_data.
    STAC.get_aos_current_pt_page; crush.
    destruct H5 with pt_addr ma pt_page; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.
    rewrite new_cache_not_shared in *; crush.
    unfold remove_new_va_cache in *; crush.
    rewrite STAC.new_get_mem_not_shared_distinct in H20; crush.
    unfold osi_current_page_table in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    destruct H5 with pt_addr ma pt_page; crush.
    unfold page_of_vadd_madd_smem; crush.
    unfold is_rw_page in *; crush.

    (* Switch *)
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o.
    destruct H9.
    destruct H10.
    STAC.get_osi_current_pt_page o.
    apply ctxt_switch_stealth_page_rw_cacheable_inv
      with s o (os_current_page x) pt_addr0 pt_addr ma; crush.
    unfold valid_sm_state; crush.
    unfold osi_pa_to_ma; crush.
    exists x1; exists x2; crush.
    rewrite Hpost with pt_addr0 in H0; crush.
    unfold osi_current_page_table; crush.
    unfold madd_type; crush.
    rewrite H14; crush.
    rewrite Hpost with pt_addr0 in H7; crush;
      unfold osi_current_page_table; crush.
    rewrite Hpost with pt_addr0 in H8; crush;
      unfold osi_current_page_table; crush.

    (* Lswitch *)
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H0); crush.
    unfold stealth_page_rw_cacheable; intros; simpl in *.
    apply ctxt_switch_stealth_page_rw_cacheable_inv
      with s (st_active_os s) p x pt_addr ma; crush.
    unfold valid_sm_state; crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H0); crush.
  Qed.

  Lemma no_stealth_page_line_inv :
    forall s s' a,
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      no_stealth_page_line s'.
  Proof.
    unfold valid_sm_state; crush.

    sm_action_induction a;
      destruct_sm_and_normal_action_sem; 
      unfold no_stealth_page_line; crush.

    (* Read *)
    rewrite <- STAC.read_same_madd_of_vadd in *; crush.
    rewrite <- STAC.read_same_madd_of_vadd in *; crush.
    
    (* Write *)
    rewrite <- STAC.write_same_madd_of_vadd_ne_pt_addr in H11; crush.
    assert (madd_type (smem_mm (st_memory s)) pt_addr = Some PT).
    assert (madd_type (smem_mm (set (st_memory s) v pt_addr0 v0))
                      pt_addr = Some PT).
    unfold madd_of_vadd, madd_page_table, madd_type in *; crush.
    destruct (page_content p2) eqn:?; crush.
    rewrite STAC.write_same_madd_type in H14; crush.
    unfold page_of_vadd_smem, madd_type, is_rw_page in *; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr0 v = Some m); 
      crush.
    apply STAC.madd_of_vadd_smem_then_mmem; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr x; unfold is_rw_page in *; crush.
    rewrite H16 in *; crush.
    rewrite H9 in *; crush.

    (* Write hyper *)
    rewrite <- STAC.write_same_madd_of_vadd_ne_pt_addr in H11; crush.
    assert (madd_type (smem_mm (st_memory s)) pt_addr = Some PT).
    assert (madd_type (smem_mm (set (st_memory s) v pt_addr0 v0))
                      pt_addr = Some PT).
    unfold madd_of_vadd, madd_page_table, madd_type in *; crush.
    destruct (page_content p2) eqn:?; crush.
    rewrite STAC.write_same_madd_type in H14; crush.
    unfold page_of_vadd_smem, madd_type, is_rw_page in *; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr0 v = Some m); 
      crush.
    apply STAC.madd_of_vadd_smem_then_mmem; crush.
    unfold page_of_vadd_madd_smem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr x; unfold is_rw_page in *; crush.
    rewrite H16 in *; crush.
    rewrite H9 in *; crush.
    
    (* Del untrusted *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr va = Some ma); 
      crush.
    remember (get_cache (smem_c (st_memory s)) (v, x2)).
    destruct o0; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    rewrite delete_mem_some_entry with (mm':=m) (ma:=x2) (pg:=p) in H11; 
      crush.
    unfold madd_of_vadd, madd_page_table in H11; crush.
    destruct (madd_eq x2 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_cache with v pt_addr p; crush.
    unfold is_rw_page in *; crush.
    rewrite H15 in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    unfold remove_page_table_entry in *; crush.
    destruct (page_content p2) eqn:?; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (vadd_eq v va); crush.
    rewrite PT.get_remove in *; crush.
    rewrite Heqc; crush.
    apply PT.get_remove_old with (k':=v); crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in *; crush.
    remember (remove_page_table_entry (smem_mm (st_memory s)) x1 v).
    destruct o0; crush.
    rewrite delete_mem_no_entry with (mm':=m) (ma:=x2) in H11; crush.
    unfold madd_of_vadd, madd_page_table in H11; crush.
    unfold remove_page_table_entry in *; crush.
    destruct (page_content p1) eqn:?; crush.
    unfold madd_of_vadd, madd_page_table; crush.
    destruct (madd_eq x1 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    destruct (vadd_eq v va); crush.
    rewrite PT.get_remove in *; crush.
    rewrite Heqc; crush.
    apply PT.get_remove_old with (k':=v); crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite delete_mem_invalid in *; crush.

    (* Page pin *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr va = Some ma);
      crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct (madd_eq x pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    injection Heqc; crush.
    rewrite PT.get_empty in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite Heqc; crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr va = Some ma);
      crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct (madd_eq x pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite Heqc; crush.

    (* Page unpin *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr va = Some ma);
      crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct (madd_eq x0 pt_addr); crush.
    rewrite <- get_add_mem in *; crush.
    rewrite get_add_mem_distinct in *; crush.
    rewrite Heqc; crush.

    (* New normal *)
    destruct (madd_eq x0 pt_addr); crush.
    (* x0 = pt_addr *)
    destruct (vadd_eq v va); crush.
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr va = Some ma); 
      crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    destruct (get_mem (smem_mm (st_memory s)) pt_addr) eqn:?; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    unfold osi_current_page_table in *; crush.
    rewrite H22; crush.
    rewrite STAC.new_get_mem_pt_addr with (pt_page:=p0) (pt:=pt) 
      in Heqopt_res0; crush.
    injection Heqc; crush.
    rewrite PT.get_set_distinct in *; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; unfold osi_current_page_table in *; 
      crush.
    STAC.get_osi_current_pt_page o; crush.
    (* x0 <> pt_addr *)
    assert (madd_of_vadd (smem_mm (st_memory s)) pt_addr va = Some ma); 
      crush.
    assert (madd_type (smem_mm (st_memory s)) pt_addr = Some PT).
    assert (madd_type (smem_mm (ACT.new s o x0 v x2)) pt_addr = Some PT).
    unfold madd_type, madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; unfold osi_current_page_table in *; 
      crush.
    rewrite STAC.new_same_madd_type with (pt_page':=pt_page) (pt':=pt) 
      in H18; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    unfold madd_of_vadd, madd_page_table in *; crush.
    destruct (page_content p1) eqn:?; crush.
    rewrite STAC.new_get_mem_distinct_pt in Heqopt_res0; crush.
    rewrite Heqc; crush.
    unfold madd_type in *; crush.
    destruct (get_mem (smem_mm (st_memory s)) x2) eqn:?; crush.
    
    (* New sm *)
    destruct (vadd_eq va stealth_va); crush.
    rewrite STAC.madd_of_vadd_new_not_shared_distinct 
      with (osi:=o) in H18; crush.
    
    (* Switch *)
    unfold ACT.pre_switch in *; crush.
    STAC.destruct_valid_state.
    destruct H_valid_os_idents with o; crush.
    STAC.get_osi_current_pt_page o; crush.
    assert (osi_current_page_table s o = Some pt_addr0); crush.
    unfold osi_current_page_table; crush.
    specialize (Hpost pt_addr0 H14); crush.
    rewrite madd_of_vadd_ctxt_switch_new_smem
      with (osi:=o) (pt_padd':=os_current_page x) in H0; crush.
    unfold osi_pa_to_ma; crush.

    (* LSwitch *)
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
    rewrite madd_of_vadd_ctxt_switch_new_smem
      with (osi:=st_active_os s) (pt_padd':=p) in H0; crush.
    unfold ACT.pre_lswitch in *; crush.
    specialize (Hpost x H8); crush.
  Qed.


  Theorem valid_sm_state_inv :
    forall s a s',
      valid_sm_state s ->
      valid_sm_exec s a s' ->
      valid_sm_state s'.
  Proof.
    Local Hint Resolve valid_state_invariant_sm
      stealth_page_cached_inv no_stealth_page_inv
      stealth_page_reserved_line_inv stealth_page_unique_inv
      stealth_page_rw_cacheable_inv no_stealth_page_line_inv.
    intros.
    generalize H; unfold valid_sm_state in H; crush.
    unfold valid_sm_state; crush.
  Qed.

End VALID_SM_STATE_INV. 
